/*
 * Copyright (c) 2012,2015 Renesas Electronics Corporation and TESSERA
 * TECHNOLOGY INC.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

//=============================================================================
// FileName : CommandProcessor.h
//=============================================================================
#pragma once

//=============================================================================
// 萔`
//=============================================================================

#define	SOH							(0x01)		// R}hEt[̃wb_
#define	STX							(0x02)		// f[^Et[̃wb_
#define	ETB							(0x17)		// f[^Et[̍ŏIt[ȊÕtb^
#define	ETX							(0x03)		// R}hEt[̃tb^A܂̓f[^Et[̍ŏIt[̃tb^
#define	INIT_SUM					(0x00)		// `FbNSUM̏l

//-----------------------------------------------------------------------------
// MR}hԍ
//-----------------------------------------------------------------------------
#define	CMD_NUM_RESET				(0x00)		// Reset
#define	CMD_NUM_BLOCK_ERASE			(0x22)		// Block Erase
#define CMD_NUM_PROGRAMMING			(0x40)		// Programming
#define	CMD_NUM_VERIFY				(0x13)		// Verify
#define CMD_NUM_BLOCK_BLANK_CHECK	(0x32)		// Block Blank Check
#define CMD_NUM_BAUD_RATE_SET		(0x9A)		// Baud Rate Set
#define CMD_NUM_SILICON_SIGNATURE	(0xC0)		// Silicon Signature
#define CMD_NUM_SECURITY_SET		(0xA0)		// Security Set
#define CMD_NUM_SECURITY_GET		(0xA1)		// Security Get
#define CMD_NUM_SECURITY_RELEASE	(0xA2)		// Security Release
#define CMD_NUM_CHECKSUM			(0xB0)		// Checksum

//-----------------------------------------------------------------------------
// Xe[^XER[h
//-----------------------------------------------------------------------------
#define STS_COMMAND_NUMBER_ERROR	(0x04)		// Command number error
#define	STS_PARAMETER_ERROR			(0x05)		// Parameter error
#define STS_ACK						(0x06)		// ACK
#define	STS_CHECKSUM_ERROR			(0x07)		// Checksum error
#define	STS_VERIFY_ERROR			(0x0F)		// Verify error
#define STS_PROTECT_ERROR			(0x10)		// Protect error
#define	STS_NACK					(0x15)		// NACK
#define	STS_ERASE_ERROR				(0x1A)		// Erase error
#define STS_IVERIFY_BLANK_ERROR		(0x1B)		// IVerify error / Blank error
#define STS_WRITE_ERROR				(0x1C)		// Write error


//-----------------------------------------------------------------------------
// [hݒ1oCgf[^iʐMC^tF[Xj
//-----------------------------------------------------------------------------
#define	COM_IF_ONE_WIRE				(0x3A)		// PUART
#define COM_IF_TWO_WIRE				(0x00)		// 2UART

//-----------------------------------------------------------------------------
// d
//-----------------------------------------------------------------------------
#define	V33							(0x21)		// 3.30V  33  0x21

//-----------------------------------------------------------------------------
// {[[gݒf[^
//-----------------------------------------------------------------------------
#define BPS_115200					(0x00)		//   115,200 bps
#define BPS_250000					(0x01)		//   250,000 bps
#define	BPS_500000					(0x02)		//   500,000 bps
#define BPS_1000000					(0x03)		// 1,000,000 bps

//-----------------------------------------------------------------------------
// f[^
//-----------------------------------------------------------------------------
#define CMD_FLAME_MAX_SIZE			(260)		// R}hEt[̍őTCYioCgj
#define DAT_FLAME_MAX_SIZE			(260)		// f[^Et[̍őTCYioCgj
#define CMD_INFO_MAX_SIZE			(255)		// (R}hEt[)R}h̍őTCYioCgj
#define DAT_DATA_MAX_SIZE			(256)		//if[^Et[́jf[^̍őTCYioCgjj
#define BLOCK_SIZE                  (1024UL)    // 1ubÑf[^TCY
#define DUMMY_BYTE                  (0xFF)      // _~[oCgf[^

//=============================================================================
// NX`
//=============================================================================
//-----------------------------------------------------------------------------
// @outline		CCommandProcessor NX
// @explanation	R}hEt[̍쐬сAf[^Et[̃`FbN
//				sNXłB
//-----------------------------------------------------------------------------
class CCommandProcessor
{
public:
	// RXgN^
	CCommandProcessor(void);
	// fXgN^
	~CCommandProcessor(void);

    // R}hEt[擾܂B
    BYTE*	GetCommandFrames() { return m_pbCmdFlames; };

    // f[^Et[擾܂B
	BYTE*	GetDataFrames()    { return m_pbDataFlames; };

	// s܂B
	DWORD	Initialize(void);

    // ResetR}hEt[쐬܂B
	DWORD	MakeResetCommand(DWORD* dwCmdLength);
	
    // ResetR}hɑ΂Xe[^XEt[`FbN܂B
	DWORD	CheckResetStatus(BYTE* pbSt1);
    
	// BaudRateR}hEt[쐬܂B
    DWORD	MakeBaudRateCommand(BYTE bBps, BYTE bVoltage, DWORD* dwCmdLength);
	
    // BaudRateR}hɑ΂Xe[^XEt[`FbN܂B
	DWORD	CheckBaudRateStatus(BYTE* pbSt1, BYTE* pbD01, BYTE* pbD02);
	
    // BlockEraseR}hEt[쐬܂B
	DWORD	MakeBlockEraseCommand(BYTE bSal, BYTE bSam, BYTE bSah, DWORD* dwCmdLength);
	
    // BlockEraseR}hɑ΂Xe[^XEt[`FbN܂B
	DWORD	CheckBlockEraseStatus(BYTE* pbSt1);
    
    // SecurityGetR}hEt[쐬܂B
    DWORD   MakeSecurityGetCommand(DWORD* dwCmdLength);

    // SecurityGetR}hɑ΂Xe[^XEt[`FbN܂B
    DWORD   CheckSecurityGetCommand(BYTE* pbSt1);

    // SecurityGertR}h̃f[^Et[`FbN܂B
    DWORD   CheckSecurityGetDataFrame(BYTE* pbFlg, BYTE* pbBot, BYTE* pbSsl, BYTE* pbSsh, BYTE* pbSel, BYTE* pbSeh);
    
	// ProgrammingR}hEt[쐬܂B
	DWORD	MakeProgrammingCommand(BYTE bSal, BYTE bSam, BYTE bSah, BYTE bEal, BYTE bEam, BYTE bEah, DWORD* dwCmdLength);
	
    // ProgrammingR}hɑ΂Xe[^XEt[`FbN܂B
	DWORD	CheckProgrammingStatus(BYTE* pbSt1);
	
    // ProgrammingR}h̃f[^Et[쐬܂B
	DWORD	MakeProgrammingDataFrame(BYTE* pbWriteData, UINT nLength, BOOL fFinalFrame, DWORD* dwCmdLength);
	
    // ProgrammingR}h̃f[^Et[ɑΉXe[^XEt[`FbN܂B
	DWORD	CheckProgrammingDataFrameStatus(BYTE* pbSt1, BYTE* pbSt2);
	
    // Sf[^]ɑ΂Xe[^XEt[`FbN܂B
	DWORD	CheckProgrammingDataFrameStatus(BYTE* pbSt1);
	
	// VerifyR}hEt[쐬܂B
	DWORD	MakeVerifyCommand(BYTE bSal, BYTE bSam, BYTE bSah, BYTE bEal, BYTE bEam, BYTE bEah, DWORD* dwCmdLength);
	
    // VerifyR}hEt[ɑ΂Xe[^XEt[`FbN܂B
	DWORD	CheckVerifyStatus(BYTE* pbSt1);
	
    // VerifyR}h̃f[^Et[쐬܂B
	DWORD	MakeVerifyDataFrame(BYTE* pbVerifyData, UINT nLength, BOOL fFinalFrame, DWORD* dwCmdLength);
	
    // VerifyR}h̃f[^Et[ɑΉXe[^XEt[`FbN܂B
	DWORD	CheckVerifyDataFrameStatus(BYTE* pbSt1, BYTE* pbSt2);

    // ChecksumR}hEt[쐬܂B
    DWORD   MakeChecksumCommand(BYTE bSal, BYTE bSam, BYTE bSah, BYTE bEal, BYTE bEam, BYTE bEah, DWORD* dwCmdLength);

    // ChecksumR}hɑ΂Xe[^XEt[`FbN܂B
    DWORD   CheckChecksumStatus(BYTE* pbSt1);

    // ChecksumR}h̃f[^Et[ɑΉXe[^XEt[`FbN܂B
    DWORD   CheckChecksumDataFrams(BYTE* pbCk1, BYTE* pbCk2);

    // SiliconSignatureR}hEt[쐬܂B
    DWORD   MakeSiliconSignatureCommand(DWORD* dwCmdLength);
    
    // SiliconSignatureR}hEt[ɑ΂Xe[^XEt[`FbN܂B
    DWORD   CheckSiliconSignatureStatus(BYTE* pbSt1);
    
    // SiliconSignatureR}h̃f[^Et[ɑΉXe[^XEt[`FbN܂B
    DWORD   CheckSiliconSignatureDataFrames(BYTE* pbDec, BYTE* pbDev, BYTE* pbCen, BYTE* pbDen, BYTE* pbVer);
    
    // BlockBlankCheckR}hEt[쐬܂B
    DWORD   MakeBlockBlankCheckCommand(BYTE bSal, BYTE bSam, BYTE bSah, BYTE bEal, BYTE bEam, BYTE bEah, BYTE bD01, DWORD* dwCmdLength);
    
    // BlockBlankCheckR}hɑ΂Xe[^XEt[`FbN܂B
    DWORD	CheckBlockBlankCheckStatus(BYTE* pbSt1);
    
    // eR}hEt[ɑΉXe[^XEt[`FbN܂B
    DWORD   CheckStatus(BYTE* pbSt1);

private:
	// R}hEt[
	BYTE*	m_pbCmdFlames;

	// f[^Et[
	BYTE*	m_pbDataFlames;

	// AhX͈͂܂ރR}ht[쐬܂B
	DWORD	makeAddressRangeCommand(BYTE bCom, BYTE bSal, BYTE bSam, BYTE bSah, BYTE bEal, BYTE bEam, BYTE bEah, DWORD* dwCmdLength);
	
    // Xe[^XEt[`FbN܂B
	DWORD	checkStatus(BYTE* pbSt1);

	// f[^Et[쐬܂B
	DWORD	makeDataFrame(BYTE* pbData, UINT nLength, BOOL fFinalFrame, DWORD* dwCmdLength);

	// f[^Et[ɑ΂Xe[^XEt[`FbN܂B
	DWORD	checkDataFrame(BYTE* pbSt1, BYTE* pbSt2);

    // `FbNSUM擾܂B
	BYTE	getCheckSum(BYTE* bFrames, int nStartIndex, int nCount);
};
