/*
 * Copyright (c) 2012,2015 Renesas Electronics Corporation and TESSERA
 * TECHNOLOGY INC.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

//=============================================================================
// FileName : Common.h
//=============================================================================
#pragma once 

//=============================================================================
// CN[h
//=============================================================================
#include "stdwin.h"
#include "Debug.h"

//-----------------------------------------------------------------------------
// ߂l
//-----------------------------------------------------------------------------
#define SW_SUCCESS						(0L)					    // I

#define SW_ERROR_SYSTEM_BASS            (0x00001000)                // VXenG[
#define SW_ERROR_SERIAL_INFO            (SW_ERROR_SYSTEM_BASS + 0)  // G[FVA|[g̎擾s
#define SW_ERROR_SERIAL_UNSELECT        (SW_ERROR_SYSTEM_BASS + 1)  // G[FVA|[gI
#define SW_ERROR_SERIAL_OPEN            (SW_ERROR_SYSTEM_BASS + 2)  // G[FVA|[g̃I[vG[
#define SW_ERROR_CHG_EEPROM             (SW_ERROR_SYSTEM_BASS + 3)  // G[FEEPROM̕ύXs
#define	SW_ERROR_MONITOR_TIMER_INIT		(SW_ERROR_SYSTEM_BASS + 4)  // G[FVAj^p^C}̍쐬Ɏs

#define SW_ERROR_BASS					(0x00002000)                // nG[
#define	SW_ERROR_INIT					(SW_ERROR_BASS + 0)			// G[Fs
#define SW_ERROR_FRAME_FORMAT			(SW_ERROR_BASS + 1)		    // G[Ft[tH[}bgs
#define SW_ERROR_PARAMETER				(SW_ERROR_BASS + 2)		    // G[Fp[^s
#define SW_ERROR_CHECKSUM				(SW_ERROR_BASS + 3)		    // G[FSUMs
#define SW_ERROR_SEND_DATA				(SW_ERROR_BASS + 4)		    // G[FMs
#define SW_ERROR_RECV_TIMEOUT			(SW_ERROR_BASS + 5)		    // G[FM^CAEg
#define SW_ERROR_SEND_TIMEOUT           (SW_ERROR_BASS + 6)         // G[FM^CAEg
#define SW_ERROR_CMD_STATUS             (SW_ERROR_BASS + 7)		    // G[FR}hEt[ɑ΂ُI
#define SW_ERROR_DATA_STATUS            (SW_ERROR_BASS + 8)         // G[Ff[^Et[ɑ΂ُI
#define SW_ERROR_MODE_CHANGE_TIMEOUT	(SW_ERROR_BASS + 9)		    // G[F[hݏ̃^CAEg
#define SW_ERROR_NO_BRANK               (SW_ERROR_BASS + 10)        // G[FuNł͂Ȃ
#define SW_ERROR_CHG_BAUDRATE           (SW_ERROR_BASS + 11)        // G[F{[[gύXs
#define SW_ERROR_BUFFER_OVER_FLOW       (SW_ERROR_BASS + 12)        // G[Fobt@[I[o[t[
#define SW_ERROR_CHECKSUM_CMD           (SW_ERROR_BASS + 13)        // G[FCehcksumR}hŎ擾lGUIŎZolقȂ

#define SW_ERROR_FIO_BASS               (0x00003000)                // t@CI/OnG[
#define SW_ERROR_FIO_NOT_FOUND          (SW_ERROR_FIO_BASS + 0)     // G[Ft@C݂܂B
#define SW_ERROR_FIO_INVALID_TYPE       (SW_ERROR_FIO_BASS + 1)     // G[FΉ`
#define SW_ERROR_FILE_SIZE              (SW_ERROR_FIO_BASS + 2)     // G[Ft@C̃TCYsłB
#define SW_ERROR_FILE_READ              (SW_ERROR_FIO_BASS + 3)     // G[Ft@C̓ǂ݂݂Ɏs܂B
#define SW_ERROR_CF_SIZE                (SW_ERROR_FIO_BASS + 4)     // G[FR[hEtbVẼTCYs
#define SW_ERROR_DF_SIZE                (SW_ERROR_FIO_BASS + 5)     // G[Ff[^EtbVẼTCYs
#define SW_ERROR_CF_START_ADDRESS       (SW_ERROR_FIO_BASS + 6)     // G[FR[hEtbVE̊JnAhXs
#define SW_ERROR_DF_START_ADDRESS       (SW_ERROR_FIO_BASS + 7)     // G[Ff[^EtbVE̊JnAhXs

//=============================================================================
// 萔`
//=============================================================================
#define CF_START_ADDRESS                (0UL)                       // R[hEtbVEJnAhX
#define DF_START_ADDRESS                (0xF1000)                   // f[^EtbVEJnAhX

#define PROC_TIME_FLG                   (TRUE)                      // vtO(TRUE:v | FALSE:vȂ)

//=============================================================================
// \̐錾
//=============================================================================
//-----------------------------------------------------------------------------
// VA|[gi[܂B
//-----------------------------------------------------------------------------
typedef struct _SERIALPORTINFO {
	INT		portNumber;				    // |[gԍ
	TCHAR	portName[MAX_PATH];		    // |[g
	TCHAR	description[MAX_PATH];      // |[g̐
} SERIALPORTINFO, *PSERIALPORTINFO, *LPSERIALPORTINFO;


//-----------------------------------------------------------------------------
// BaudRateSetR}hɑ΂Xe[^Xi[܂B
//-----------------------------------------------------------------------------
typedef struct _BAUDRATESETSTAT {
    BYTE    D01;                        // g(EFCg^C̊l)
    BYTE    D02;                        // vO~OE[h̐ݒl(0x00:tXs[h | 0x01:Ch{e[W)
} BAUDRATESETSTAT, *PBAUDRATESETSTAT, *LPBAUDRATESETSTAT;


//-----------------------------------------------------------------------------
// VREVOl`R}hɑ΂f[^Et[i[܂B
//-----------------------------------------------------------------------------
typedef struct _SILICONSIGNATURE {
    BYTE    DevCode[3];                 // DECFfoCXR[h
    BYTE    DevName[10+1];              // DEVFfoCX
    BYTE    CodeEndAddress[3];          // CENFR[hEtbVROMŏIAhX
    BYTE    DataEndAddress[3];          // DENFf[^EtbVROMŏIAhX
    BYTE    FVer[3];                    // VERFt@[EFAEo[W
} SILICONSIGNATURE, *PSILICONSIGNATURE, *LPSILICONSIGNATURE;


//-----------------------------------------------------------------------------
// Security GetR}hɑ΂f[^Et[i[܂B
//-----------------------------------------------------------------------------
typedef struct _SECURITYGETINFO {
    BYTE    Flg;                        // FLGFZLeBEtO
    BYTE    Bot;                        // BOTFu[gEubNENX^EubNԍ
    BYTE    Ssl;                        // SSLFtbVEV[hEEBhEJnubNԍiʁj
    BYTE    Ssh;                        // SSHFtbVEV[hEEBhEJnubNԍiʁj
    BYTE    Sel;                        // SELFtbVEV[hEEBhEIubNԍiʁj
    BYTE    Seh;                        // SEHFtbVEV[hEEBhEIubNԍiʁj
} SECURITYGETINFO, *PSECURITYGETINFO, *LPSECURITYGETINFO;


//-----------------------------------------------------------------------------
// ^[QbgEt@C̏i[܂B
//-----------------------------------------------------------------------------
typedef struct _TARGETFILEINFO {
    TCHAR               FilePath[MAX_PATH]; // ^[Qbgt@C̃tpX
    DWORD               ProgramAddress;     // vOË̊JnAhX
    DWORD               ProgramSize;        // vOË̃TCY
    DWORD               DataAddress;        // f[^EtbV̈̊JnAhX
    DWORD               DataSize;           // f[^EtbV̈̃TCY
} TARGETFILEINFO, *PTARGETFILEINFO, *LPTARGETFILEINFO;


//-----------------------------------------------------------------------------
// R}hi[܂B
//-----------------------------------------------------------------------------
typedef struct _COMMANDINFO {
    BYTE                Command;            // R}hԍ
    BYTE                ST1;                // ST01(o   | R}hM)
                                            //      0x04FT|[gĂȂR}hMꍇ̃G[)
                                            //      0x05FR}hɕtp[^K؂ȒlłȂꍇ̃G[
                                            //      0x06F퉞
                                            //      0x07FMf[^Et[Ɉُ킪ꍇ̃G[
                                            //      0x0FFvO}]ꂽf[^Ƃ̃xt@Cł̃G[
                                            //      0x10FSecurity SetR}hŋ֎~s悤Ƃꍇ̃G[
                                            //      0x15Fے艞
                                            //      0x1AFG[
                                            //      0x1BFxt@CEG[A܂̓uNE`FbNEG[
                                            //      0x1CF݃G[

    BYTE                DST1;               // ST01(f[^M | xCt@C)
    BYTE                DST2;               // ST02(݌   | xt@C)
    DWORD               Retry;              // gC
} COMMANDINFO, *PCOMMANDINFO, *LPCOMMANDINFO;


//-----------------------------------------------------------------------------
// ݌ʏi[܂B
//-----------------------------------------------------------------------------
typedef struct _RESULTINFO {
    DWORD           Result;
    COMMANDINFO     ComInfo;
} RESULTINFO, *PRESULTINFO, *LPRESULTINFO;

//-----------------------------------------------------------------------------
// foCXύXi[܂B
//-----------------------------------------------------------------------------
typedef struct _DEVCHANGEINFO {
    BOOL                IsDeviceChange;     // foCXύXʒmtOiTRUE:ʒm|FALSE:ʒmȂj
    UINT                PortNumber;         // foCXύXĎ|[gԍ
    HANDLE              hNotify;            // ʒm
} DEVCHANGEINFO, *PDEVCHANGEINFO, *LPDEVCHANGEINFO;

//-----------------------------------------------------------------------------
// ReLXgi[܂B
//-----------------------------------------------------------------------------
typedef struct _CONTEXTINFO {
    BOOL                IsInvertDtr;        // DTR]tO(TRUE:]|FALSE:񔽓])
    PDEVCHANGEINFO      pDevInfo;           // foCXύX
    BYTE                BaudRate;           // {[[g(0x00:115,200bps|0x01:250,000bps|0x02:500,000bps|0x03:1,000,000bps)
    PRESULTINFO         pResultInfo;        // ݌ʏ̃|C^
    HWND                ParentWindow;       // Ăяo
    HWND                NotifyProgress;     // i̒ʒm
    HWND                UpdateLog;          // F/WXVO̒ʒm
    UINT                PortNumber;         // VA|[gԍ
    TARGETFILEINFO      TargetFileInfo;     // ^[QbgEt@C̏
    BAUDRATESETSTAT     BaudRateStat;       // BaudRateSetR}h̃Xe[^X
    SILICONSIGNATURE    SiliconSignature;   // SiliconSignatureR}h̃f[^Et[
    SECURITYGETINFO     SecurityGetInfo;    // SecurityGetR}h̃f[^Et[
    COMMANDINFO         ComInfo;            // R}h
    DWORD               TransitionStartTime;// vO~OE[hJڂ̊Jn
    DWORD               TransitionEndTime;  // vO~OE[hJڂ̏I
    DWORD               ComRetryMax;        // R}h̍ő呗MgC
    DWORD               RetryWaitTime;      // gC̑҂(msec)
    DWORD               SendWait;           // ftHg̑MOEFCg(msec)
    DWORD               ReceiveTimeout;     // ftHg̃f[^M^CAEgl(msec)
} CONTEXTINFO, *PCONTEXTINFO, *LPCONTEXTINFO;

//-----------------------------------------------------------------------------
//	{[[gi[܂B
//-----------------------------------------------------------------------------
typedef struct _SERIAL_BAUD_RATE {
    DWORD				BaudRate;			// {[[g
} SERIAL_BAUD_RATE, *PSERIAL_BAUD_RATE;

//-----------------------------------------------------------------------------
// ii[܂B
//-----------------------------------------------------------------------------
typedef struct _PROGRESSINIFO {
    DWORD   Step;               // Xebv
    DWORD   CurrentProgress;    // ݒl
    DOUBLE  Share;              // Ŝɑ΂銄
    DWORD   InitProgress;       // l
    DOUBLE  Incremental;        // l
} PROGRESSINIFO, *PPROGRESSINIFO, *LPPROGRESSINIFO;

//=============================================================================
// [UbZ[W`
//=============================================================================
#define WM_USER_UPDATE_PROGRESS         (WM_USER + 100)         // [UbZ[WFi̍XV
#define WM_USER_RESULT                  (WM_USER + 101)         // [UbZ[WFs
#define WM_USER_INIT_UPDATE_LOG         (WM_USER + 102)         // [UbZ[WFF/WXVONA

#define SW_STEP_BASS                    (100)                   
#define SW_STEP_FILE_READ               (SW_STEP_BASS + 0)      // XebvFΏۃt@C̓ǂ݂
#define SW_STEP_MODE_CHANGE             (SW_STEP_BASS + 1)      // XebvF
#define SW_STEP_BLOCK_ERASE             (SW_STEP_BASS + 2)      // XebvFubNC[X
#define SW_STEP_PROGRAMMING             (SW_STEP_BASS + 3)      // XebvFvO~O
#define SW_STEP_CHG_EEPROM              (SW_STEP_BASS + 4)      // XebvFEEPROM
