/*
 * Copyright (c) 2012,2015 Renesas Electronics Corporation and TESSERA
 * TECHNOLOGY INC.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

//=============================================================================
// FileName : CScopedLock.h
//=============================================================================
#pragma once

//=============================================================================
// CN[h
//=============================================================================
#include "Common.h"

//=============================================================================
// NX`
//=============================================================================
//-----------------------------------------------------------------------------
// @outline		CScopedLock NX
// @explanation	rsNXłB
//-----------------------------------------------------------------------------
class CScopedLock
{
public:
    //-----------------------------------------------------------------------------
    // @outline		RXgN^
    // @explanation	RXgN^
    // @param		hMutex  rŎgpMutexw肵܂B
    // @return		none
    //-----------------------------------------------------------------------------
	CScopedLock(HANDLE hMutex): m_hMutex(hMutex) {
		
        // Mutex擾
        if (m_hMutex){
            WaitForSingleObject(m_hMutex, 0);
		} 
	}

    //-----------------------------------------------------------------------------
    // @outline		fXgN^
    // @explanation	fXgN^
    // @param		none
    // @return		none
    //-----------------------------------------------------------------------------
	virtual ~CScopedLock() {

        // Mutex
        if (m_hMutex){
			ReleaseMutex(m_hMutex);
		}
	}

private:
    // rpMutex
	HANDLE      m_hMutex;
};
