/*
 * Copyright (c) 2012,2015 Renesas Electronics Corporation and TESSERA
 * TECHNOLOGY INC.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

//=============================================================================
// CSequenceProcessor NX
//=============================================================================
#include "SequenceProcessor.h"

//-----------------------------------------------------------------------------
// @outline		RXgN^
// @explanation	RXgN^
// @param		none
// @return		none
//-----------------------------------------------------------------------------
CSequenceProcessor::CSequenceProcessor(void)
{
    // }`fBA^C}̐\l擾Ɛݒ
	timeGetDevCaps(&m_Timecaps, sizeof(TIMECAPS));
    timeBeginPeriod(m_Timecaps.wPeriodMin);
}

//-----------------------------------------------------------------------------
// @outline		fXgN^
// @explanation	fXgN^
// @param		none
// @return		none
//-----------------------------------------------------------------------------
CSequenceProcessor::~CSequenceProcessor(void)
{
    // }`fBA^C}̐ݒlZbg
	timeEndPeriod(m_Timecaps.wPeriodMin);
}


//-----------------------------------------------------------------------------
// @outline		s܂B
// @explanation	s܂B
// @param		[IN]nPortNumber	|[gԍw肵܂B
// @return		ɐꍇɂ 0 Asꍇɂ 0 ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CSequenceProcessor::Initialize()
{
	DWORD	dwRet = SW_SUCCESS;


	// R}hENX̏
	dwRet = m_Cmd.Initialize();

    
	return dwRet;
}


//-----------------------------------------------------------------------------
// @outline		vO~OXbh֐擾܂B
// @explanation	vO~OXbh֐擾܂B
// @param		[IN]lpParameter	Jñp[^w肵܂B
// @return		vO~OXbhƂē삷֐̃AhXԂ܂B
//-----------------------------------------------------------------------------
DWORD WINAPI CSequenceProcessor::getThreadFunc(LPVOID lpvParameter)
{
    return ((CSequenceProcessor*)lpvParameter)->programming(); 
}

#if _DEBUG
//-----------------------------------------------------------------------------
// @outline		fobOF[h݌
// @explanation	fobOF[h݌
// @param		[IN]dwRet   ߂lw肵܂B
// @return		none
//-----------------------------------------------------------------------------
void CSequenceProcessor::DEBUG_MODE_RESULT(DWORD dwRet)
{
    wstring   caption, message;
    TCHAR buff[1024];
    
    wsprintf(buff, _T("ERROR = 0x%08X (%d)\r\n"), dwRet, dwRet);
    message += buff;
    wsprintf(buff, _T("ProcTime = %d msec\r\n"), (m_ContextInfo.TransitionEndTime - m_ContextInfo.TransitionStartTime));
    message += buff;
    wsprintf(buff, _T("D01 = 0x%02X\r\n"), m_ContextInfo.BaudRateStat.D01);
    message += buff;
    wsprintf(buff, _T("D02 = 0x%02X\r\n"), m_ContextInfo.BaudRateStat.D02);
    message += buff;
    string s((char*)m_ContextInfo.SiliconSignature.DevName);
    TCHAR buff2[sizeof(m_ContextInfo.SiliconSignature.DevName)];
    size_t ret;
    mbstowcs_s(&ret, buff2, sizeof(m_ContextInfo.SiliconSignature.DevName), s.c_str(), _TRUNCATE);
    wsprintf(buff, _T("DEV = %s\r\n"), buff2);
    message += buff;
    wsprintf(buff, _T("CEN = 0x%06X\r\n"), makeAddress(m_ContextInfo.SiliconSignature.CodeEndAddress[0],
                                                       m_ContextInfo.SiliconSignature.CodeEndAddress[1],
                                                       m_ContextInfo.SiliconSignature.CodeEndAddress[2]));
    message += buff;

    wsprintf(buff, _T("DEN = 0x%06X\r\n"), makeAddress(m_ContextInfo.SiliconSignature.DataEndAddress[0],
                                                       m_ContextInfo.SiliconSignature.DataEndAddress[1],
                                                       m_ContextInfo.SiliconSignature.DataEndAddress[2]));
    message += buff;
    wsprintf(buff, _T("Retry = %d\r\n"), m_ContextInfo.ComInfo.Retry);
    message += buff;
        
    if (SW_SUCCESS != dwRet) {
        caption = _T("[hEݏs");
    }
    else {
        caption = _T("[hEݏ");
    }
        
    MessageBox(m_ContextInfo.NotifyProgress, message.c_str(), caption.c_str(), MB_OK);

    if (SW_SUCCESS == dwRet) {
        
        m_Wait.Initialize(
            m_ContextInfo.BaudRateStat.D01,
            m_ContextInfo.BaudRateStat.D02 == 0x00 ? TRUE: FALSE);
        DTRACE(_T("tCS1               = %u\r\n"), m_Wait.GetResetTcs1());
#if 0
		DTRACE(_T("tCS2(TRUE)         = %u\r\n"), m_Wait.GetVerifyTcs2(TRUE));
        DTRACE(_T("tCS2(FALSE)        = %u\r\n"), m_Wait.GetVerifyTcs2(FALSE));
        DTRACE(_T("tDS2(TRUE)         = %u\r\n"), m_Wait.GetVerifyTds2(TRUE));
        DTRACE(_T("tDS2(FALSE)        = %u\r\n"), m_Wait.GetVerifyTds2(FALSE));
#endif
		DTRACE(_T("tCS3(TRUE)         = %u\r\n"), m_Wait.GetBlockEraseTcs3(TRUE));
        DTRACE(_T("tCS3(FALSE)        = %u\r\n"), m_Wait.GetBlockEraseTcs3(FALSE));
        DTRACE(_T("tCS4(TRUE)         = %u\r\n"), m_Wait.GetBlockBlankCheckTcs4(0x00000000, 0x000003FF, 1, TRUE));
        DTRACE(_T("tCS4(FALSE)        = %u\r\n"), m_Wait.GetBlockBlankCheckTcs4(0x00000000, 0x000003FF, 1, FALSE));
        DTRACE(_T("tCS5(TRUE)         = %u\r\n"), m_Wait.GetProgrammingTcs5(TRUE));
        DTRACE(_T("tCS5(FALSE)        = %u\r\n"), m_Wait.GetProgrammingTcs5(FALSE));
        DTRACE(_T("tDS5(TRUE)         = %u\r\n"), m_Wait.GetProgrammingTds5(TRUE));
        DTRACE(_T("tDS5(FALSE)        = %u\r\n"), m_Wait.GetProgrammingTds5(FALSE));
        DTRACE(_T("tSS5(TRUE)    1BLK = %u\r\n"), m_Wait.GetProgrammingTss5(0x00000000, 0x000003FF, 1, TRUE));
        DTRACE(_T("tSS5(TRUE)   30BLK = %u\r\n"), m_Wait.GetProgrammingTss5(0x00000000, 0x000077FF,30, TRUE));
        DTRACE(_T("tSS5(FALSE)   1BLK = %u\r\n"), m_Wait.GetProgrammingTss5(0x00000000, 0x000003FF, 1, FALSE));
        DTRACE(_T("tSS5(FALSE)  30BLK = %u\r\n"), m_Wait.GetProgrammingTss5(0x00000000, 0x000077FF,30, FALSE));
        DTRACE(_T("tCS6               = %u\r\n"), CWaitingTimeCalculator::GetBaudRateSetTcs6());
        DTRACE(_T("tCS7               = %u\r\n"), m_Wait.GetSecuritySetTcs7());
        DTRACE(_T("tDS7               = %u\r\n"), m_Wait.GetSecuritySetTds7());
        DTRACE(_T("tCS8               = %u\r\n"), m_Wait.GetSecurityGetTcs8());
        DTRACE(_T("tSD8               = %u\r\n"), m_Wait.GetSecurityGetTsd8());
        DTRACE(_T("tCS9               = %u\r\n"), m_Wait.GetSecurityReleaseTcs9(256, 8));
        DTRACE(_T("tCS10(TRUE)        = %u\r\n"), m_Wait.GetCheckSumTcs10(TRUE));
        DTRACE(_T("tCS10(FALSE)       = %u\r\n"), m_Wait.GetCheckSumTcs10(FALSE));
        DTRACE(_T("tSD10              = %u\r\n"), m_Wait.GetCheckSumTsd10(1));
        DTRACE(_T("tCS11              = %u\r\n"), m_Wait.GetSiliconSignatureTcs11());
        DTRACE(_T("tSD11              = %u\r\n"), m_Wait.GetSiliconSignatureTsd11());
        DTRACE(_T("tST11              = %u\r\n"), m_Wait.GetTdt());
    }
}

//-----------------------------------------------------------------------------
// @outline		fobOFs
// @explanation	fobOFs
// @param		[IN]dwRet       ߂lw肵܂B
//              [IN]dwPassTime  oߎԂw肵܂B
// @return		none
//-----------------------------------------------------------------------------
void CSequenceProcessor::DEBUG_RESULT(DWORD dwRet, DWORD dwPassTime)
{
    wstring s;
    TCHAR   buff[1024];
    wsprintf(buff, _T("pass = %d\r\n"),             dwPassTime);
    s += buff;
    wsprintf(buff, _T("dwRet = 0x%08X\r\n"),        dwRet);
    s += buff;
    wsprintf(buff, _T("comNumber = 0x%02X\r\n"),    m_ContextInfo.ComInfo.Command);
    s += buff;
    wsprintf(buff, _T("ST1  = 0x%02X\r\n"),         m_ContextInfo.ComInfo.ST1);
    s += buff;
    wsprintf(buff, _T("DST1 = 0x%02X\r\n"),         m_ContextInfo.ComInfo.DST1);
    s += buff;
    wsprintf(buff, _T("DST2 = 0x%02X\r\n"),         m_ContextInfo.ComInfo.DST2);
    s += buff;
    MessageBox(m_ContextInfo.NotifyProgress, s.c_str(), _T(""), MB_OK);
}
#endif

//-----------------------------------------------------------------------------
// @outline		vO~Os܂B
// @explanation	vO~Os܂B
// @param		none
// @return		ɏIłꍇɂ SW_SUCCESSAɏIłȂꍇɂ SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD WINAPI CSequenceProcessor::programming() 
{
    DWORD           dwRet           = SW_SUCCESS;   // ߂l
    DCB		        dcb;                            // DCB\
    DWORD           dwPGStartAddr   = 0UL;
    DWORD           dwPGEndAddr     = 0UL;
    DWORD           dwPGSize        = 0UL;
    DWORD           dwPGBlockCount  = 0UL;
    DWORD           dwPGRemainSize  = 0UL;

    DWORD           dwDFStartAddr   = 0UL;
    DWORD           dwDFEndAddr     = 0UL;
    DWORD           dwDFSize        = 0UL;
    DWORD           dwDFBlockCount  = 0UL;
    DWORD           dwDFRemainSize  = 0UL;
    BOOL            fInvertDtr      = FALSE;

#if PROC_TIME_FLG
    DWORD           dwStartTime     = 0UL;          // vFJn
    DWORD           dwEndTime       = 0UL;          // vFI
    DWORD           dwPassTime      = 0UL;          // vFoߎ
#endif

    // i\̂̏
    ZeroMemory(&m_Progress, sizeof(PROGRESSINIFO));

    // ݒlZbg
    m_ContextInfo.ComRetryMax       = 5UL;      // ő僊gC
    m_ContextInfo.ReceiveTimeout    = 200UL;    // ftHg̃f[^M^CAEg (msec)
    m_ContextInfo.RetryWaitTime     = 100UL;    // gCԊu(msec)
    m_ContextInfo.SendWait          = 1UL;      // ftHg̑MOEFCg(msec)

    // MEMO:i̐U蕪
    //      oCit@C̏ꍇ
    //       5    [h
    //       5    t@C
    //      10    uN`FbNEC[X
    //      80    vO~O

    // iXV
    m_Progress.Step             = SW_STEP_MODE_CHANGE;
    m_Progress.CurrentProgress  = 0UL;
    UpdateProgress(m_Progress.Step, m_Progress.CurrentProgress);

    // VA|[g̐ݒ
    memset(&dcb, 0, sizeof(DCB));               // DCB\̂̏
    dcb.DCBlength       = sizeof(DCB) ;         // DCB\̂̃TCY
    dcb.fBinary         = TRUE;                 // Windows̓oCi[ĥ݃T|[g
	dcb.BaudRate	    = CBR_115200;			// {[[g		F115200bps
    dcb.Parity		    = NOPARITY;				// peBrbg	FȂ
	dcb.ByteSize	    = 8;					// f[^			F8rbg
    dcb.StopBits	    = TWOSTOPBITS;			// Xgbvrbg	F2rbg
    dcb.fDtrControl     = DTR_CONTROL_DISABLE;  // DTR𖳌


#if PROC_TIME_FLG
    // JnԂZbg
    dwStartTime = timeGetTime();
#endif

    // VA|[gI[v
    if (SW_SUCCESS == dwRet) {
        dwRet = m_ComPort.Open(m_ContextInfo.PortNumber, &dcb);
        if (SW_SUCCESS == dwRet) {
            // MXbh̋N҂
            while (FALSE == m_ComPort.IsReading()) {
                Sleep(0);
            }
        }
    }

    // vO~OE[h֑J
    if (SW_SUCCESS == dwRet) {
        DTRACE(_T("## Programming Mode\r\n"));

        // F/WXVOo
        putUpdateLog(_T("## Programming Mode\r\n"));

        m_Progress.Step  = SW_STEP_MODE_CHANGE;
        m_Progress.Share = 5UL;

        fInvertDtr = FALSE;
        dwRet = programingMode(m_ContextInfo.BaudRate, V33, fInvertDtr);
        if (SW_ERROR_MODE_CHANGE_TIMEOUT == dwRet) {
            fInvertDtr = TRUE;
            dwRet = programingMode(m_ContextInfo.BaudRate, V33, fInvertDtr);
        }

        m_Progress.CurrentProgress  += 5UL;
        UpdateProgress(m_Progress.Step, m_Progress.CurrentProgress);
    }
    
#if _DEBUG
        DEBUG_MODE_RESULT(dwRet);
#endif

    // Ώۃt@C̓ǂ݂
    if (SW_SUCCESS == dwRet) {
        m_Progress.Step  = SW_STEP_FILE_READ;
        m_Progress.Share = 5UL;
        UpdateProgress(m_Progress.Step, m_Progress.CurrentProgress);

        dwRet = m_TargetFile.ReadFile(m_ContextInfo.TargetFileInfo.FilePath);
        
        m_Progress.CurrentProgress += 5;
        UpdateProgress(m_Progress.Step, m_Progress.CurrentProgress);
    }
    
    if (SW_SUCCESS == dwRet) {
        // iXV
        m_Progress.Step         = SW_STEP_BLOCK_ERASE;
        m_Progress.Share        = 10;
        m_Progress.InitProgress = m_Progress.CurrentProgress;
        UpdateProgress(m_Progress.Step, m_Progress.CurrentProgress);


        // vOẼAhXZbg
        dwPGStartAddr   = 0;
        dwPGSize        = m_TargetFile.GetProgramMemorySize();
        dwPGBlockCount  = dwPGSize / BLOCK_SIZE;
        dwPGRemainSize  = dwPGSize % BLOCK_SIZE;
        if (0UL < dwPGRemainSize) {
            dwPGBlockCount++;
        }

        // TCYƃAhX͈͂̃`FbN
        if (SW_SUCCESS == dwRet) {
            dwRet = checkSizeAndAddressRange(CF_START_ADDRESS, 
                                             m_TargetFile.GetProgramMemorySize(), 
                                             DF_START_ADDRESS,
                                             m_TargetFile.GetDataSize());
        }
    }
    
    // ubNEuNE`FbNƃubNEuNEC[X
    if (SW_SUCCESS == dwRet) {

        // ȋlݒ
        m_Progress.Incremental = m_Progress.Share / dwPGBlockCount;
        
        // IAhX擾
        dwPGEndAddr = dwPGStartAddr + (BLOCK_SIZE *  dwPGBlockCount) - 1;
        DTRACE(_T("StartAddress = 0x%08X:EndAddress = 0x%08X:Size = %u:BlockCount = %u:RemainSize = %u\r\n"), 
            dwPGStartAddr, dwPGEndAddr, dwPGSize, dwPGBlockCount, dwPGRemainSize);

		// F/WXVOo
		putUpdateLog(_T("## Block Blank Check & Erace..."));

        for (DWORD i = 0; i < dwPGBlockCount; i++) {
            // iXV
            m_Progress.CurrentProgress = m_Progress.InitProgress + (DWORD)(m_Progress.Incremental * (i + 1));
            UpdateProgress(m_Progress.Step, m_Progress.CurrentProgress);

            // ubNEuNE`FbN
            DTRACE(_T("## Block Blank Check\r\n"));

            dwRet = comBlockBlankCheckProc(dwPGStartAddr + BLOCK_SIZE * i, TRUE);

            // uNłȂꍇ͏
            if (SW_ERROR_NO_BRANK == dwRet) {
                DTRACE(_T("## Block Erace\r\n"));

                dwRet = comBlockEraseProc(dwPGStartAddr + BLOCK_SIZE * i, TRUE);
			}

            // p
            if (SW_SUCCESS != dwRet) {
                break;
            }
        }

		// ʂOo
		putUpdateLog(getResultText(dwRet));
	}

    // vO~O
    if (SW_SUCCESS == dwRet) {
        // ȉlZbg
        m_Progress.InitProgress = m_Progress.CurrentProgress;
        m_Progress.Step = SW_STEP_PROGRAMMING;
        m_Progress.Share = 80;

        UpdateProgress(m_Progress.Step, m_Progress.CurrentProgress);

        DTRACE(_T("## Programming\r\n"));

        // F/WXVOo
        putUpdateLog(_T("## Programming..."));

        dwRet = comProgrammingProc(dwPGStartAddr,
                                    dwPGEndAddr, 
                                    m_TargetFile.GetProgramMemory(),
                                    dwPGSize,
                                    TRUE); 
		DTRACE(_T("## END Programming\r\n"));

		
		// ʂOo
		putUpdateLog(getResultText(dwRet));
    }

    // `FbNTEf[^̎擾Ɣr
    if (SW_SUCCESS == dwRet) {
        WORD    checksum    = 0UL;  // Mf[^̃`FbNT
        BYTE    bCk1        = 0x00; // CK1(`FbNTEf[^̉8rbg)
        BYTE    bCk2        = 0x00; // CK2(`FbNTEf[^̏8rbg)

        // Mf[^̃`FbNT擾
        if (SW_SUCCESS == dwRet) {
            dwRet = getChecksum(m_TargetFile.GetProgramMemory(), dwPGSize, &checksum);
        }

        // `FbNTEf[^̎擾
        dwRet = comChecksum(dwPGStartAddr,
                            dwPGEndAddr,
                            &bCk1,
                            &bCk2,
                            TRUE);
      
        // r
        if (SW_SUCCESS == dwRet) {
            if (bCk1 != (BYTE)(checksum & 0x00FF) ||
                bCk2 != (BYTE)((checksum & 0xFF00) >> 8)) {
                dwRet = SW_ERROR_CHECKSUM_CMD;
            }
        }
    }

    DTRACE(_T("## Reset before shutdown\r\n"));

    // dՒfȌiZbgj
    if (TRUE == fInvertDtr) {
        m_ComPort.ClearDtr();
    }
    else {
        m_ComPort.SetDtr();
    }
    
    DTRACE(_T("## Close\r\n"));

    // VA|[g
    m_ComPort.Close();

    // EEPROM̐ݒ
    if (SW_SUCCESS == dwRet && fInvertDtr != m_ContextInfo.IsInvertDtr) {
		    
		// F/WXVOo
	    putUpdateLog(_T("## EEPROM Write..."));

        m_Progress.Step = SW_STEP_CHG_EEPROM;
        UpdateProgress(m_Progress.Step, m_Progress.CurrentProgress);
        
        dwRet = CSerialPortProcessor::InvertDTR(m_ContextInfo.pDevInfo);

		// ʂOo
		putUpdateLog(getResultText(SW_SUCCESS));
    }

    // ʂĂяo֒ʒm
    m_ContextInfo.pResultInfo->Result  = dwRet;
    m_ContextInfo.pResultInfo->ComInfo = m_ContextInfo.ComInfo;
    SendMessage(m_ContextInfo.ParentWindow, WM_USER_RESULT, 0, 0);

    // i_CAO
    DTRACE(_T("## Send close message\r\n"));

    SendMessage(m_ContextInfo.NotifyProgress, WM_SYSCOMMAND, SC_CLOSE, 0);

	// F/WXVOo
	if( dwRet == SW_SUCCESS ) {
		putUpdateLog(_T("## Write Complete\r\n"));
	}
	else {
		putUpdateLog(_T("## Write Failed\r\n"));
	}

#if PROC_TIME_FLG
    // IԎ擾
    dwEndTime   = timeGetTime();
    // oߎԎ擾
    dwPassTime  = dwEndTime - dwStartTime;
#endif
#if _DEBUG
#if PROC_TIME_FLG
    DEBUG_RESULT(dwRet, dwPassTime);
#else
    DEBUG_RESULT(dwRet, 0UL);
#endif
#endif
    DTRACE(_T("0x%08X\r\n"), dwRet);
    
    return dwRet;
}


//-----------------------------------------------------------------------------
// @outline		F/W̏Jn܂B
// @explanation	F/W̏Jn܂B
// @param		[IN]contextInfo ReLXgw肵܂B
// @return		ɊJnłꍇɂ SW_SUCCESSAɊJnłȂꍇɂ SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CSequenceProcessor::Start(CONTEXTINFO contextInfo)
{
    DWORD	dwRet = SW_SUCCESS;


    m_ContextInfo = contextInfo;

    // F/WXVÕNA
    SendMessage(m_ContextInfo.UpdateLog, WM_USER_INIT_UPDATE_LOG, 0, 0);

    // Xbh쐬
    if (SW_SUCCESS == dwRet) {
	    m_hThread = CreateThread(NULL,
							     0, 
							     getThreadFunc,
							     (LPVOID)this,
							     CREATE_SUSPENDED,
							     &m_dwThreadId);
	    if (m_hThread == NULL) {
            dwRet = SW_ERROR_INIT;
	    }
    }

    // Xbh̋N
    if (NULL != m_hThread) {
        ResumeThread(m_hThread);
    }

    return dwRet;
}


//-----------------------------------------------------------------------------
// @outline		iXV܂B
// @explanation	iXV܂B
// @param		[IN]dwStep          iXebvw肵܂B
//              [IN]dwPercentage    iw肵܂B
// @return		ɍXVłꍇɂ SW_SUCCESSAɍXVłȂꍇɂ SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
LRESULT CSequenceProcessor::UpdateProgress(DWORD dwStep, DWORD dwPercentage)
{
    return SendMessage(m_ContextInfo.NotifyProgress, WM_USER_UPDATE_PROGRESS, (WPARAM)dwStep, (LPARAM)dwPercentage);
}


//-----------------------------------------------------------------------------
// @outline		UARTʐMݒ̃{[E[gݒ肨ѓdݒf[^̐ݒs܂B
// @explanation	UARTʐMݒ̃{[E[gݒ肨ѓdݒf[^̐ݒs܂B
// @param		[IN]bBaudRate   {[[glw肵܂B(0x00 = 115,200bps | 0x01 = 250,000bps | 0x02 = 500,000 bps | 0x03 = 1,000,000 bps)
//              [IN]bVoltage    dw肵܂B(:)3.30V -> 33 -> 0x21:dl̏ʂ܂ł̒l16iƂĎw肵܂B)
// @return		ݒłꍇɂ SW_SUCCESS AݒłȂꍇɂ SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CSequenceProcessor::comBaudRateSetProc(BYTE bBaudRate, BYTE bVoltage) 
{
    DWORD   dwRet       = SW_SUCCESS;   // ߂l
    BOOL    fRetry      = FALSE;        // gCtO
    DWORD   dwRetry     = 0UL;          // gC
    DWORD   dwCmdLength = 0UL;          // R}hEt[̒
    DWORD   dwRecvLen   = 0UL;          // Mobt@ǂݏoTCY
    DWORD   dwLength    = 0UL;          // Mobt@ǂݏoTCY

    // R}h
    initCommandInfo(CMD_NUM_BAUD_RATE_SET);

    for (DWORD i = dwRetry = 0; i < m_ContextInfo.ComRetryMax; i++, dwRetry++) {
        // gC񐔂Zbg
        m_ContextInfo.ComInfo.Retry = i;
        // gCtONA
        fRetry = FALSE;
	    // BaudRateݒR}hM
	    if (SW_SUCCESS == dwRet) {
		    // MOEFCg
            wait(m_ContextInfo.SendWait);

		    // BaudRateݒR}h쐬B
            dwCmdLength = 0UL;
            dwRet = m_Cmd.MakeBaudRateCommand(bBaudRate, bVoltage, &dwCmdLength);
        
            // M
            if (SW_SUCCESS == dwRet) {
                dwRet = m_ComPort.SendData(m_Cmd.GetCommandFrames(), dwCmdLength);
            }

            // 100msecȓ̏ԑI
            m_ContextInfo.TransitionEndTime = timeGetTime();
	    }
        
        // BaudRateݒR}hɑ΂Xe[^XEt[̎M҂
        if (SW_SUCCESS == dwRet) {
            dwLength = 0UL;
            dwRet = waitStatusFrames(&dwLength, m_ContextInfo.ReceiveTimeout);

            if (SW_ERROR_RECV_TIMEOUT == dwRet) {
                // ^CAEgȂ烊gCtOZbg
                fRetry = TRUE;
            }
        }

        if (FALSE == fRetry) {
            break;
        }
        else {
            // gCEFCg
            wait(m_ContextInfo.RetryWaitTime);
            // G[l߂
            dwRet = SW_SUCCESS;
        }
    }

    // vO~OE[h̐ԃ`FbN
    if (SW_SUCCESS == dwRet) {
        // ܂ł̏100msecȓŊĂȂꍇ̓G[ƂB
        if (100UL < (m_ContextInfo.TransitionEndTime - m_ContextInfo.TransitionStartTime)) {
            dwRet = SW_ERROR_MODE_CHANGE_TIMEOUT;
        }
    }

    // BaudRateݒR}hɑ΂Xe[^XEt[̃`FbN
	if (SW_SUCCESS == dwRet) {
        // Mf[^擾
        // MEMO:R}hsȏꍇD01D02ȗꂽXe[^XEt[ԂĂB
        dwRecvLen = m_ComPort.GetReceivedData(m_Cmd.GetDataFrames(), DAT_FLAME_MAX_SIZE, dwLength);
        if (7UL == dwRecvLen) {
            // BaudRateݒR}hɑ΂Xe[^XEt[̃`FbN
            dwRet = m_Cmd.CheckBaudRateStatus(&m_ContextInfo.ComInfo.ST1, 
                                                &m_ContextInfo.BaudRateStat.D01, 
                                                &m_ContextInfo.BaudRateStat.D02);
        }
        else if (5UL == dwRecvLen){
            dwRet = m_Cmd.CheckStatus(&m_ContextInfo.ComInfo.ST1);
        }
        else {
            // M^CAEg
            dwRet = SW_ERROR_RECV_TIMEOUT;
        }

		if (SW_SUCCESS == dwRet) {
            if (STS_ACK != m_ContextInfo.ComInfo.ST1) {
				// ُI
				dwRet = SW_ERROR_CMD_STATUS;
			}
		}
	}

    return dwRet;
}


//-----------------------------------------------------------------------------
// @outline		ύX{[E[gł̓mFs܂B
// @explanation	ύX{[E[gł̓mFs܂B
// @param		none
// @return		mFłꍇɂ SW_SUCCESS AmFłȂꍇɂ SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CSequenceProcessor::comResetProc()
{
    DWORD   dwRet       = SW_SUCCESS;   // ߂l
    BOOL    fRetry      = FALSE;        // gCtO
    DWORD   dwRetry     = 0UL;          // gC
    DWORD   dwCmdLength = 0UL;          // R}hEt[̒
    DWORD   dwRecvLen   = 0UL;          // Mobt@ǂݏoTCY
    DWORD   dwLength    = 0UL;          // Mobt@ǂݏoTCY
    DWORD   dwtCS1      = 0x00;         // ^CAEg(tCS1)

    // R}h
    initCommandInfo(CMD_NUM_RESET);

    // ^CAEgԂZbg
    dwtCS1 = m_Wait.GetResetTcs1();

    for (DWORD i = dwRetry = 0; i < m_ContextInfo.ComRetryMax; i++, dwRetry++) {
        // gC񐔂Zbg
        m_ContextInfo.ComInfo.Retry = i;
        // gCtONA
        fRetry = FALSE;
        // ResetR}hM
	    if (SW_SUCCESS == dwRet) {
            // MOEFCg
            wait(m_ContextInfo.SendWait);

            // ResetR}h쐬B
            dwRet = m_Cmd.MakeResetCommand(&dwCmdLength);
        
            if (SW_SUCCESS == dwRet) {
                // M
		        dwRet = m_ComPort.SendData(m_Cmd.GetCommandFrames(), dwCmdLength);
            }
	    }

        // ResetR}hɑ΂Xe[^XEt[̎M҂
        if (SW_SUCCESS == dwRet) {
            dwLength = 0UL;
            dwRet = waitStatusFrames(&dwLength, dwtCS1);
        }

        if (SW_ERROR_RECV_TIMEOUT == dwRet) {
            // ^CAEgȂ烊gCtOZbg
            fRetry = TRUE;
        }

        if (FALSE == fRetry) {
            break;
        }
        else {
            // gCEFCg
            wait(m_ContextInfo.RetryWaitTime);
            // G[l߂
            dwRet = SW_SUCCESS;
        }
    }

	// ResetR}hɑ΂Xe[^XEt[̃`FbN
	if (SW_SUCCESS == dwRet) {
        // Mf[^擾
		dwRecvLen = m_ComPort.GetReceivedData(m_Cmd.GetDataFrames(), DAT_FLAME_MAX_SIZE, dwLength);
		
        // ResetR}hɑ΂Xe[^XEt[̃`FbN
        if (5UL == dwRecvLen) {
		    dwRet = m_Cmd.CheckResetStatus(&m_ContextInfo.ComInfo.ST1);
		    if (SW_SUCCESS == dwRet) {
			    if (STS_ACK != m_ContextInfo.ComInfo.ST1) {
				    dwRet = SW_ERROR_CMD_STATUS;
			    }
		    }
        }
        else {
            // M^CAEg
            dwRet = SW_ERROR_RECV_TIMEOUT;
        }
	}

    return dwRet;
}


//-----------------------------------------------------------------------------
// @outline		RL78ȉiVREVOl`jǂݏo܂B
// @explanation	RL78ȉiVREVOl`jǂݏo܂B
// @param		none
// @return		ǂݏoꍇɂ SW_SUCCESS AǂݏoȂꍇɂ SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CSequenceProcessor::comSiliconSignatureProc()
{
    DWORD   dwRet       = SW_SUCCESS;   // ߂l
    BOOL    fRetry      = FALSE;        // gCtO
    DWORD   dwRetry     = 0UL;          // gC
    DWORD   dwCmdLength = 0UL;          // R}hEt[̒
    DWORD   dwRecvLen   = 0UL;          // Mobt@ǂݏoTCY
    DWORD   dwLength    = 0UL;          // Mobt@ǂݏoTCY
    DWORD   dwtCS11     = 0x00;         // ^CAEg(tCS11)
    DWORD   dwtSD11     = 0x00;         // ^CAEg(tSD11)

    // R}h
    initCommandInfo(CMD_NUM_SILICON_SIGNATURE);

    // ^CAEgԂZbg
    dwtCS11 = m_Wait.GetSiliconSignatureTcs11();
    dwtSD11 = m_Wait.GetSiliconSignatureTsd11();

    for (DWORD i = dwRetry = 0; i < m_ContextInfo.ComRetryMax; i++, dwRetry++) {
        // gC񐔂Zbg
        m_ContextInfo.ComInfo.Retry = i;
        // gCtONA
        fRetry = FALSE;
        // Silicon SignatureR}h̑M
        if (SW_SUCCESS == dwRet) {
            // MOEFCg
            wait(m_ContextInfo.SendWait);

            // Silicon SignatureR}h쐬B
            dwRet = m_Cmd.MakeSiliconSignatureCommand(&dwCmdLength);

            // Silicon SignatureR}hEt[擾B
            if (SW_SUCCESS == dwRet) {
                // M
                dwRet = m_ComPort.SendData(m_Cmd.GetCommandFrames(), dwCmdLength);
            }
        }

        // Silicon SignatureR}hɑ΂Xe[^XEt[̎M҂
        if (SW_SUCCESS == dwRet) {
            dwLength = 0UL;
            dwRet = waitStatusFrames(&dwLength, dwtCS11);
        }

        if (SW_ERROR_RECV_TIMEOUT == dwRet) {
            // ^CAEgȂ烊gCtOZbg
            fRetry = TRUE;
        }

        if (FALSE == fRetry) {
            break;
        }
        else {
            // gCEFCg
            wait(m_ContextInfo.RetryWaitTime);
            // G[l߂
            dwRet = SW_SUCCESS;
        }
    }

    // Silicon SignatureR}hɑ΂Xe[^XEt[̃`FbN
    if (SW_SUCCESS == dwRet) {
        // Mf[^擾
		dwRecvLen = m_ComPort.GetReceivedData(m_Cmd.GetDataFrames(), DAT_FLAME_MAX_SIZE, dwLength);
		
        // Silicon SignatureR}hɑ΂Xe[^XEt[̃`FbN
        if (5UL == dwRecvLen) {
            dwRet = m_Cmd.CheckResetStatus(&m_ContextInfo.ComInfo.ST1);
		    if (SW_SUCCESS == dwRet) {
			    if (STS_ACK != m_ContextInfo.ComInfo.ST1) {
				    dwRet = SW_ERROR_CMD_STATUS;
			    }
		    }
        }
        else {
            // M^CAEg
    		dwRet = SW_ERROR_RECV_TIMEOUT;
        }
    }

    // Sillicon SignatureR}hɑ΂f[^Et[̎M҂
    if (SW_SUCCESS == dwRet) {
        dwLength = 0UL;
        dwRet = waitStatusFrames(&dwLength, dwtSD11);
    }

    if (SW_SUCCESS == dwRet) {
        // Mf[^擾
        dwRecvLen = m_ComPort.GetReceivedData(m_Cmd.GetDataFrames(), DAT_FLAME_MAX_SIZE, dwLength);
		
        // Silicon SignatureR}hɑ΂f[^Et[̃`FbN
        if (26UL == dwRecvLen) {
            dwRet = m_Cmd.CheckSiliconSignatureDataFrames(
                m_ContextInfo.SiliconSignature.DevCode,
                m_ContextInfo.SiliconSignature.DevName,
                m_ContextInfo.SiliconSignature.CodeEndAddress,
                m_ContextInfo.SiliconSignature.DataEndAddress,
                m_ContextInfo.SiliconSignature.FVer);
        }
        else {
            // M^CAEg
    		dwRet = SW_ERROR_RECV_TIMEOUT;
        }
    }
    
    return dwRet;
}


//-----------------------------------------------------------------------------
// @outline		w肵ubN܂B
// @explanation	w肵ubN܂B
// @param		[IN]dwStartAddress  ubNEC[XJnAhXw肵܂B
//              [IN]fCodeFlash      R[hEtbV̏ꍇ TRUE Af[^EtbV̏ꍇ FALSE w肵܂B
// @return		łꍇɂ SW_SUCCESS AłȂꍇɂ SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CSequenceProcessor::comBlockEraseProc(DWORD dwStartAddress, BOOL fCodeFlash)
{
    DWORD   dwRet           = SW_SUCCESS;   // ߂l
    BOOL    fRetry          = FALSE;        // gCtO
    DWORD   dwRetry         = 0UL;          // gC
    DWORD   dwCmdLength     = 0UL;          // R}hEt[̒
    DWORD   dwRecvLen       = 0UL;          // Mobt@ǂݏoTCY
    DWORD   dwLength        = 0UL;          // Mobt@ǂݏoTCY
    BYTE    bSal            = 0x00;         // JnAhX Low    (rbg 7 - rbg 0)
    BYTE    bSam            = 0x00;         // JnAhX Middle (rbg15 - rbg 8)
    BYTE    bSah            = 0x00;         // JnAhX High   (rbg23 - rbg16)
    DWORD   dwtCS3          = 0x00;         // ^CAEg҂(tCS3)

    // R}h
    initCommandInfo(CMD_NUM_BLOCK_ERASE);

    // JnAhX𕪉
    splitAddress(dwStartAddress, &bSah, &bSam, &bSal);
    DTRACE(_T("dwStartAddress = 0x%08X\r\n"), dwStartAddress);

    // ^CAEgԂZbg
    dwtCS3 = m_Wait.GetBlockEraseTcs3(fCodeFlash);

    for (DWORD i = dwRetry = 0; i < m_ContextInfo.ComRetryMax; i++, dwRetry++) {
        // gC񐔂Zbg
        m_ContextInfo.ComInfo.Retry = i;
        // gCtONA
        fRetry = FALSE;
        // BlockEraseR}hM
	    if (SW_SUCCESS == dwRet) {
            // MOEFCg
            wait(m_ContextInfo.SendWait);

            // BlockEraseR}h쐬B
            dwRet = m_Cmd.MakeBlockEraseCommand(bSal, bSam, bSah, &dwCmdLength);
        
            if (SW_SUCCESS == dwRet) {
                // M
		        dwRet = m_ComPort.SendData(m_Cmd.GetCommandFrames(), dwCmdLength);
            }
	    }

        // BlockEraseR}hɑ΂Xe[^XEt[̎M҂
        if (SW_SUCCESS == dwRet) {
            dwLength = 0UL;
            dwRet = waitStatusFrames(&dwLength, dwtCS3);
        }

        if (SW_ERROR_RECV_TIMEOUT == dwRet) {
            // ^CAEgȂ烊gCtOZbg
            fRetry = TRUE;
        }

        if (FALSE == fRetry) {
            break;
        }
        else {
            // gCEFCg
            wait(m_ContextInfo.RetryWaitTime);
            // G[l߂
            dwRet = SW_SUCCESS;
        }
    }

	// BlockEraseR}hɑ΂Xe[^XEt[̃`FbN
	if (SW_SUCCESS == dwRet) {
        // Mf[^擾
		dwRecvLen = m_ComPort.GetReceivedData(m_Cmd.GetDataFrames(), DAT_FLAME_MAX_SIZE, dwLength);
		
        // BlockEraseR}hɑ΂Xe[^XEt[̃`FbN
        if (5UL == dwRecvLen) {
            dwRet = m_Cmd.CheckResetStatus(&m_ContextInfo.ComInfo.ST1);
		    if (SW_SUCCESS == dwRet) {
			    if (STS_ACK != m_ContextInfo.ComInfo.ST1) {
				    dwRet = SW_ERROR_CMD_STATUS;
			    }
		    }
        }
        else {
            // M^CAEg
            dwRet = SW_ERROR_RECV_TIMEOUT;
        }
	}

    return dwRet;
}


//-----------------------------------------------------------------------------
// @outline		RL78ɐݒ肳ĂZLeB擾܂B
// @explanation	RL78ɐݒ肳ĂZLeB
//              i݁AubNAu[gEubNENX^̋/֎~A
//                             tbVEV[hEEBhE̐ݒȂǁj擾܂B
// @param		none
// @return		łꍇɂ SW_SUCCESS AłȂꍇɂ SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CSequenceProcessor::comSecrityGetProc()
{
    DWORD   dwRet       = SW_SUCCESS;   // ߂l
    BOOL    fRetry      = FALSE;        // gCtO
    DWORD   dwRetry     = 0UL;          // gC
    DWORD   dwCmdLength = 0UL;          // R}hEt[̒
    DWORD   dwRecvLen   = 0UL;          // Mobt@ǂݏoTCY
    DWORD   dwLength    = 0UL;          // Mobt@ǂݏoTCY
    DWORD   dwtCS8      = 0x00;         // M^CAEgl(tCS8)
    DWORD   dwtSD8      = 0x00;         // M^CAEgl(tSD8)

    // R}h
    initCommandInfo(CMD_NUM_SECURITY_GET);

    // M^CAEglZbg
    dwtCS8 = m_Wait.GetSecurityGetTcs8();
    dwtSD8 = m_Wait.GetSecurityGetTsd8();

    for (DWORD i = dwRetry = 0; i < m_ContextInfo.ComRetryMax; i++, dwRetry++) {
        // gC񐔂Zbg
        m_ContextInfo.ComInfo.Retry = i;
        // gCtONA
        fRetry = FALSE;
        // Security GetR}h̑M
        if (SW_SUCCESS == dwRet) {
            // MOEFCg
            wait(m_ContextInfo.SendWait);

            // Security GetR}h쐬B
            dwRet = m_Cmd.MakeSecurityGetCommand(&dwCmdLength);

            // M
            if (SW_SUCCESS == dwRet) {
                dwRet = m_ComPort.SendData(m_Cmd.GetCommandFrames(), dwCmdLength);
            }
        }

        // Security GetR}hɑ΂Xe[^XEt[̎M҂
        if (SW_SUCCESS == dwRet) {
            dwLength = 0UL;
            dwRet = waitStatusFrames(&dwLength, dwtCS8);
        }

        if (SW_ERROR_RECV_TIMEOUT == dwRet) {
            // ^CAEgȂ烊gCtOZbg
            fRetry = TRUE;
        }

        if (FALSE == fRetry) {
            break;
        }
        else {
            // gCEFCg
            wait(m_ContextInfo.RetryWaitTime);
            // G[l߂
            dwRet = SW_SUCCESS;
        }
    }

    // Security GetR}hɑ΂Xe[^XEt[̃`FbN
    if (SW_SUCCESS == dwRet) {
        // Mf[^擾
		dwRecvLen = m_ComPort.GetReceivedData(m_Cmd.GetDataFrames(), DAT_FLAME_MAX_SIZE, dwLength);
		
        // Security GetR}hɑ΂Xe[^XEt[̃`FbN
        if (5UL == dwRecvLen) {
            dwRet = m_Cmd.CheckSecurityGetCommand(&m_ContextInfo.ComInfo.ST1);
		    if (SW_SUCCESS == dwRet) {
			    if (STS_ACK != m_ContextInfo.ComInfo.ST1) {
				    dwRet = SW_ERROR_CMD_STATUS;
			    }
		    }
        }
        else {
            // M^CAEg
    		dwRet = SW_ERROR_RECV_TIMEOUT;
        }
    }

    // Security GetR}hɑ΂f[^Et[̎M҂
    if (SW_SUCCESS == dwRet) {
        dwLength = 0UL;
        dwRet = waitStatusFrames(&dwLength, dwtSD8);
    }

    if (SW_SUCCESS == dwRet) {
        // Mf[^擾
        dwRecvLen = m_ComPort.GetReceivedData(m_Cmd.GetDataFrames(), DAT_FLAME_MAX_SIZE, dwLength);
	
        // Security GetR}hɑ΂f[^Et[̃`FbN
        if (12UL == dwRecvLen) {
            dwRet = m_Cmd.CheckSecurityGetDataFrame(
                &m_ContextInfo.SecurityGetInfo.Flg,
                &m_ContextInfo.SecurityGetInfo.Bot,
                &m_ContextInfo.SecurityGetInfo.Ssl,
                &m_ContextInfo.SecurityGetInfo.Ssh,
                &m_ContextInfo.SecurityGetInfo.Sel,
                &m_ContextInfo.SecurityGetInfo.Seh);
        }
        else {
            // M^CAEg
    		dwRet = SW_ERROR_RECV_TIMEOUT;
        }
    }

    return dwRet ;
}


//-----------------------------------------------------------------------------
// @outline		w肵ubNuNł邩`FbN܂B
// @explanation	w肵ubNuNł邩`FbN܂B
// @param		[IN]dwStartAddress  ubNEuNE`FbNJnAhXw肵܂B
//              [IN]fCodeFlash      R[hEtbV̏ꍇ TRUE Af[^EtbV̏ꍇ FALSE w肵܂B
// @return		uNłꍇɂ SW_SUCCESS AuNłȂꍇɂ SW_ERROR_NO_BRANK  G[̏ꍇɂ͂̑̒lԂ܂B
//-----------------------------------------------------------------------------
DWORD CSequenceProcessor::comBlockBlankCheckProc(DWORD dwStartAddress, BOOL fCodeFlash)
{
    DWORD   dwRet           = SW_SUCCESS;   // ߂l
    BOOL    fRetry          = FALSE;        // gCtO
    DWORD   dwRetry         = 0UL;          // gC
    DWORD   dwCmdLength     = 0UL;          // R}hEt[̒
    DWORD   dwRecvLen       = 0UL;          // Mobt@ǂݏoTCY
    DWORD   dwLength        = 0UL;          // Mobt@ǂݏoTCY
    BYTE    bD01            = 0x00;         // uNE`FbNẅ
    BYTE    bSah            = 0x00;         // JnAhX High   (rbg23 - rbg16)
    BYTE    bSam            = 0x00;         // JnAhX Middle (rbg15 - rbg 8)
    BYTE    bSal            = 0x00;         // JnAhX Low    (rbg 7 - rbg 0)
    BYTE    bEah            = 0x00;         // IAhX High   (rbg23 - rbg16)
    BYTE    bEam            = 0x00;         // IAhX Middle (rbg15 - rbg 8)
    BYTE    bEal            = 0x00;         // IAhX Low    (rbg 7 - rbg 0)
    DWORD   dwEndAddress    = 0x0;
    DWORD   dwtCS4          = 0x00;         // ^CAEg(tCS4)
		
    // R}h
    initCommandInfo(CMD_NUM_BLOCK_BLANK_CHECK);

    // JnAhX𕪉
    splitAddress(dwStartAddress, &bSah, &bSam, &bSal);

    // IAhX擾
    dwEndAddress = dwStartAddress + BLOCK_SIZE - 1;
    
    // IAhX𕪉
    splitAddress(dwEndAddress, &bEah, &bEam, &bEal);
    
    // ^CAEgԂ擾
    dwtCS4 = m_Wait.GetBlockBlankCheckTcs4(makeAddress(bSah, bSam, bSal),
                                           makeAddress(bEah, bEam, bEal), 1UL, fCodeFlash);


    for (DWORD i = dwRetry = 0; i < m_ContextInfo.ComRetryMax; i++, dwRetry++) {
        // gC񐔂Zbg
        m_ContextInfo.ComInfo.Retry = i;
        // gCtONA
        fRetry = FALSE;
        // BlockBlankCheckR}hM
	    if (SW_SUCCESS == dwRet) {
            // MOEFCg
            wait(m_ContextInfo.SendWait);

            // BlockBlankCheckR}h쐬B
            dwRet = m_Cmd.MakeBlockBlankCheckCommand(bSal, bSam, bSah, bEal, bEam, bEah, bD01, &dwCmdLength);
        
            if (SW_SUCCESS == dwRet) {
                // M
		        dwRet = m_ComPort.SendData(m_Cmd.GetCommandFrames(), dwCmdLength);
            }
	    }

        // BlockBlankCheckR}hɑ΂Xe[^XEt[̎M҂
        if (SW_SUCCESS == dwRet) {
            dwLength = 0UL;
            dwRet = waitStatusFrames(&dwLength, dwtCS4);
        }

        if (SW_ERROR_RECV_TIMEOUT == dwRet) {
            // ^CAEgȂ烊gCtOZbg
            fRetry = TRUE;
        }

        if (FALSE == fRetry) {
            break;
        }
        else {
            // gCEFCg
            wait(m_ContextInfo.RetryWaitTime);
            // G[l߂
            dwRet = SW_SUCCESS;
        }
    }

	// BlockBlankCheckR}hɑ΂Xe[^XEt[̃`FbN
	if (SW_SUCCESS == dwRet) {
        // Mf[^擾
		dwRecvLen = m_ComPort.GetReceivedData(m_Cmd.GetDataFrames(), DAT_FLAME_MAX_SIZE, dwLength);
		
        // BlockBlankCheckR}hɑ΂Xe[^XEt[̃`FbN
        if (5UL == dwRecvLen) {
            dwRet = m_Cmd.CheckBlockBlankCheckStatus(&m_ContextInfo.ComInfo.ST1);
		    if (SW_SUCCESS == dwRet) {
                if (STS_ACK != m_ContextInfo.ComInfo.ST1) {
                    if (STS_IVERIFY_BLANK_ERROR == m_ContextInfo.ComInfo.ST1) {
                        dwRet = SW_ERROR_NO_BRANK;
                    }
                    else {
                        dwRet = SW_ERROR_CMD_STATUS;
                    }
			    }
		    }
        }
        else {
            // M^CAEg
            dwRet = SW_ERROR_RECV_TIMEOUT;
        }
	}

    return dwRet;
}


//-----------------------------------------------------------------------------
// @outline		[UEvO~OtbVEɏ݂܂B
// @explanation	[UEvO~OtbVEɏ݂܂B
// @param		[IN]dwStartAddress  ݊JnAhXw肵܂B
//              [IN]dwEndAddress    ݏIAhXw肵܂B
//              [IN]pbData          [UEvOf[^̃|C^w肵܂B
//              [IN]dwDataLength    [UEvOf[^̃TCYw肵܂B
//              [IN]fCodeFlash      R[hEtbV̏ꍇ TRUE Af[^EtbV̏ꍇ FALSE w肵܂B
// @return		ɏ݂łꍇɂ SW_SUCCESS Aɏ݂łȂꍇɂ SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CSequenceProcessor::comProgrammingProc(DWORD dwStartAddress, DWORD dwEndAddress, BYTE* pbData, DWORD dwDataLength, BOOL fCodeFlash)
{
    DWORD   dwRet           = SW_SUCCESS;                   // ߂l
    BOOL    fRetry          = FALSE;                        // gCtO
    DWORD   dwRetry         = 0UL;                          // gC
    DWORD   dwCmdLength     = 0UL;                          // R}hEt[̒
    DWORD   dwRecvLen       = 0UL;                          // Mobt@ǂݏoTCY
    DWORD   dwLength        = 0UL;                          // Mobt@ǂݏoTCY
    BYTE    bSal            = 0x00;                         // ݊JnAhX Low    (rbg 7 - rbg 0)
    BYTE    bSam            = 0x00;                         // ݊JnAhX Middle (rbg15 - rbg 8)
    BYTE    bSah            = 0x00;                         // ݊JnAhX High   (rbg23 - rbg16)
    BYTE    bEal            = 0x00;                         // ݏIAhX Low    (rbg 7 - rbg 0)
    BYTE    bEam            = 0x00;                         // ݏIAhX Middle (rbg15 - rbg 8)
    BYTE    bEah            = 0x00;                         // ݏIAhX High   (rbg23 - rbg16)
    DWORD   dwBlockCount    = dwDataLength / BLOCK_SIZE;    // ubN (]f[^TCY  ubNTCY)
    DWORD   dwRemainByte    = dwDataLength % BLOCK_SIZE;    // c
    BYTE*   pbDataBlockAddr = NULL;                         // ]f[^̐擪|C^(ubNP)
    BYTE*   pbFinalFrame    = NULL;                         // ŏIt[f[^̐擪|C^i[L̏ꍇj
    BYTE*   pbDataAddr      = NULL;                         // ۂ̓]f[^̐擪|C^i]TCYPʁj
    BOOL    fFraction       = FALSE;                        // [tO
    BOOL    fFinalFrame     = FALSE;                        // ŏIt[tO
    DWORD   dwtCS5          = 0x00;                         // ^CAEg(tCS5)
    DWORD   dwtDS5          = 0x00;                         // ^CAEg(tDS5)
    DWORD   dwtSS5          = 0x00;                         // ^CAEg(tSS5)

    // R}h
    initCommandInfo(CMD_NUM_PROGRAMMING);

    // ]ubN擾
    if (0UL < dwRemainByte) {
        dwBlockCount++;
    }

    // ĩCNgl擾
    m_Progress.Incremental = m_Progress.Share / dwBlockCount;

    // ^CAEgԂZbg
    dwtCS5 = m_Wait.GetProgrammingTcs5(fCodeFlash);
    dwtDS5 = m_Wait.GetProgrammingTds5(fCodeFlash);
    dwtSS5 = m_Wait.GetProgrammingTss5(dwStartAddress, dwEndAddress, dwBlockCount, fCodeFlash);

    // JnAhX𕪉
    splitAddress(dwStartAddress, &bSah, &bSam, &bSal);
    DTRACE(_T("dwStartAddress = 0x%08X\r\n"), dwStartAddress);

    // IAhX𕪉
    splitAddress(dwEndAddress,   &bEah, &bEam, &bEal);
    DTRACE(_T("dwEndAddress   = 0x%08X\r\n"), dwEndAddress);

    for (DWORD i = dwRetry = 0; i < m_ContextInfo.ComRetryMax; i++, dwRetry++) {
        // gC񐔂Zbg
        m_ContextInfo.ComInfo.Retry = i;
        // gCtONA
        fRetry = FALSE;
        // ProgrammingR}h̑M
        if (SW_SUCCESS == dwRet) {
            // MOEFCg
            wait(m_ContextInfo.SendWait);

            // ProgrammingR}h쐬B
            dwRet = m_Cmd.MakeProgrammingCommand(bSal, bSam, bSah, bEal, bEam, bEah, &dwCmdLength);

            // M
            if (SW_SUCCESS == dwRet) {
                dwRet = m_ComPort.SendData(m_Cmd.GetCommandFrames(), dwCmdLength);
            }
        }

        // programmingR}hɑ΂Xe[^XEt[̎M҂
        if (SW_SUCCESS == dwRet) {
            dwLength = 0UL;
            dwRet = waitStatusFrames(&dwLength, dwtCS5);
        }

        // ^CAEgȂ烊gCtOZbg
        if (SW_ERROR_RECV_TIMEOUT == dwRet) {
            fRetry = TRUE;
        }

        if (FALSE == fRetry) {
            break;
        }
        else {
            // gCEFCg
            wait(m_ContextInfo.RetryWaitTime);
            // G[l߂
            dwRet = SW_SUCCESS;
        }
    }

    // PrograminngR}hɑ΂Xe[^XEt[̃`FbN
    if (SW_SUCCESS == dwRet) {
        // Mf[^擾
		dwRecvLen = m_ComPort.GetReceivedData(m_Cmd.GetDataFrames(), DAT_FLAME_MAX_SIZE, dwLength);
		
        // ProgrammingR}hɑ΂Xe[^XEt[̃`FbN
        if (5UL == dwRecvLen) {
            dwRet = m_Cmd.CheckProgrammingStatus(&m_ContextInfo.ComInfo.ST1);
		    if (SW_SUCCESS == dwRet) {
                DTRACE(_T("Programming@ST1 = 0x%02X\r\n"), m_ContextInfo.ComInfo.ST1);

			    if (STS_ACK != m_ContextInfo.ComInfo.ST1) {
				    dwRet = SW_ERROR_CMD_STATUS;
			    }
		    }
        }
        else {
            // M^CAEg
    		dwRet = SW_ERROR_RECV_TIMEOUT;
        }
    }

    // ---- f[^] ----

    DTRACE(_T("dwDataLength = %d\r\n"), dwDataLength);

    DTRACE(_T("pbData       = 0x%08X\r\n"), pbData);

    // c݂ꍇ͍ŏIt[̐ݒsB
    // cf[^ȊO̓_~[oCgŖ߂B
    if (0UL < dwRemainByte) {
        // [tOZbg
        fFraction = TRUE;
        // ŏIt[p̃m
        pbFinalFrame = (BYTE*)malloc(BLOCK_SIZE);
        if (NULL == pbFinalFrame) {
            dwRet = SW_ERROR_INIT;
        }
        else {
            // x_~[f[^Ŗ߂B
            memset(pbFinalFrame, DUMMY_BYTE, BLOCK_SIZE);
            // cf[^Rs[B
            memcpy_s(pbFinalFrame, 
                     BLOCK_SIZE, 
                     pbData + (BLOCK_SIZE * (dwBlockCount - 1)),
                     dwRemainByte);

            DTRACE(_T("pbFinalFrame = 0x%08X\r\n"), pbFinalFrame);
        }
    }

    DTRACE(_T("fFraction = %s\r\n"), fFraction == TRUE ? _T("TRUE") : _T("FALSE"));
    
    if (SW_SUCCESS == dwRet) {
        DTRACE(_T("dwBlockCount = %d\r\n"), dwBlockCount);

        DTRACE(_T("dwRemainByte = %d\r\n"), dwRemainByte);

        fFinalFrame = FALSE;
        // ubN
        for (DWORD i = 0; i < dwBlockCount; i++) {
            // p
            if (SW_SUCCESS != dwRet) {
                break;
            }

            // ]f[^̃AhXݒiubNPʁj
            if (TRUE == fFraction && i == (dwBlockCount - 1)) {
                pbDataBlockAddr = pbFinalFrame;
            }
            else {
                pbDataBlockAddr = pbData + (i * BLOCK_SIZE);
            }

            // i̍XV
            m_Progress.CurrentProgress = m_Progress.InitProgress + (DWORD)(m_Progress.Incremental * (i + 1));
            UpdateProgress(m_Progress.Step, m_Progress.CurrentProgress);
            
            // 
            for (DWORD j = 0; j < (BLOCK_SIZE / DAT_DATA_MAX_SIZE); j++) {
                // p
                if (SW_SUCCESS != dwRet) {
                    break;
                }
                for (DWORD k = dwRetry = 0; k < m_ContextInfo.ComRetryMax; k++) {
                    // gC񐔂Zbg
                    m_ContextInfo.ComInfo.Retry = k;
                    // gCtONA
                    fRetry = FALSE;
                    // ŏIt[mF
                    if (i == (dwBlockCount - 1) && j == (BLOCK_SIZE / DAT_DATA_MAX_SIZE) - 1) {
                        // ŏIt[tOZbg
                        fFinalFrame = TRUE;
                    }
                    // ۂɓ]f[^̐擪|C^擾
                    pbDataAddr = pbDataBlockAddr + (j * DAT_DATA_MAX_SIZE);

                    DTRACE(_T("--\r\n"));
                    DTRACE(_T("i           = %d\r\n"), i);
                    DTRACE(_T("j           = %d\r\n"), j);
                    DTRACE(_T("k(Retry)    = %d\r\n"), k);
                    DTRACE(_T("pbDataAddr  = 0x%08X\r\n"), pbDataAddr);
                    DTRACE(_T("Length      = %d\r\n"), DAT_DATA_MAX_SIZE);
                    DTRACE(_T("fFinalFrame = %s\r\n"), fFinalFrame == TRUE ? _T("TRUE") : _T("FALSE"));

#if _DEBUG
                    const int DISP_COUNT = 16;
                    TCHAR   buff[2048];
                    wstring szBuff;
                    
                    if (TRUE) {
                        for ( UINT x = 0; x < (DAT_DATA_MAX_SIZE); x++ ) {
                            if ( x % DISP_COUNT == 0 ) {
                                wsprintf(buff, _T("%07X0 "),((i * BLOCK_SIZE / DISP_COUNT) + (j * DAT_DATA_MAX_SIZE) / DISP_COUNT) + x / DISP_COUNT);
                                szBuff += buff;
                            }
                            wsprintf(buff, _T("%02X "), pbDataAddr[x]);
                            szBuff += buff;
                            if (x % DISP_COUNT == (DISP_COUNT - 1)) {
                                wsprintf(buff,_T("\r\n"));
                                szBuff += buff;
                            }
                        }
                        DTRACE(_T("%s\r\n"), szBuff);
                    }
#endif
                    // ProgrammingR}hɑ΂f[^Et[쐬B
                    dwRet = m_Cmd.MakeProgrammingDataFrame(pbDataAddr, DAT_DATA_MAX_SIZE, fFinalFrame, &dwCmdLength);

                    // MOEFCg
                    wait(m_ContextInfo.SendWait);

                    // M
                    if (SW_SUCCESS == dwRet) {
                        dwRet = m_ComPort.SendData(m_Cmd.GetCommandFrames(), dwCmdLength);
                    }

                    // ҂
                    if (SW_SUCCESS == dwRet) {
                        dwLength = 0UL;
                        dwRet = waitStatusFrames(&dwLength, dwtDS5);
                        DTRACE(_T("wait response send data frame (dwLength = %u)(tDS5=%u)-> dwRet = 0x%08X\r\n"), dwLength, dwtDS5, dwRet);
                    }

                    // Mf[^擾
                    if (SW_SUCCESS == dwRet) {
                        dwRecvLen = m_ComPort.GetReceivedData(m_Cmd.GetDataFrames(), DAT_FLAME_MAX_SIZE, dwLength);
                        DTRACE(_T("wait send data frame -> dwRecvLen = %u\r\n"), dwRecvLen);
		
                        // R}hɑ΂f[^Et[̃`FbN
                        if (6UL == dwRecvLen) {
                            dwRet = m_Cmd.CheckProgrammingDataFrameStatus(&m_ContextInfo.ComInfo.DST1, &m_ContextInfo.ComInfo.DST2);
                            DTRACE(_T("dwRet = 0x%08X\r\n"), dwRet);
                            if (SW_SUCCESS == dwRet) {
                                DTRACE(_T("DST1 = 0x%02X\r\nDST2 = 0x%02X\r\n"), m_ContextInfo.ComInfo.DST1, m_ContextInfo.ComInfo.DST2);
                                if (STS_ACK != m_ContextInfo.ComInfo.DST1 || STS_ACK != m_ContextInfo.ComInfo.DST2) {
                                    dwRet = SW_ERROR_DATA_STATUS;
                                }
                            }
                        }
                        else if (5UL == dwRecvLen) {
                            dwRet = m_Cmd.CheckProgrammingDataFrameStatus(&m_ContextInfo.ComInfo.DST1);
                            if (SW_SUCCESS == dwRet) {
                                DTRACE(_T("DST1=0x%02X\r\n"), m_ContextInfo.ComInfo.DST1);
                                if (STS_ACK != m_ContextInfo.ComInfo.DST1) {
                                    dwRet = SW_ERROR_DATA_STATUS;
                                }
                            }
                        }
                        else {
                            // M^CAEg
    		                dwRet = SW_ERROR_RECV_TIMEOUT;
                        }

                        if (SW_SUCCESS != dwRet) {
                            // ُI
                            break;
                        }
                    }

                    // Sf[^]Xe[^XEt[̎M҂
                    if (SW_SUCCESS == dwRet && TRUE == fFinalFrame) {
                        dwLength = 0UL;
                        dwRet = waitStatusFrames(&dwLength, dwtSS5);
                        // xt@Cʂ擾
                        if (SW_SUCCESS == dwRet) {
                            dwRecvLen = m_ComPort.GetReceivedData(m_Cmd.GetDataFrames(), DAT_FLAME_MAX_SIZE, dwLength);
                            if (5UL == dwRecvLen) {
                                dwRet = m_Cmd.CheckProgrammingDataFrameStatus(&m_ContextInfo.ComInfo.DST1);
                                if (SW_SUCCESS == dwRet) {
                                    DTRACE(_T("Internal Verify DST1=0x%02X\r\n"), m_ContextInfo.ComInfo.DST1);
                                    if (STS_ACK != m_ContextInfo.ComInfo.DST1) {
                                        dwRet = SW_ERROR_DATA_STATUS;
                                    }
                                }
                            }
                            else {
                                // M^CAEg
    		                    dwRet = SW_ERROR_RECV_TIMEOUT;
                            }

                            if (SW_SUCCESS != dwRet) {
                                // ُI
                                break;
                            }
                        }
                    }

                    // IłȂꍇgCtOZbg
                    if (SW_SUCCESS != dwRet) {
                        dwRetry++;
                        fRetry = TRUE;
                    }

                    if (FALSE == fRetry) {
                        break;
                    }
                    else {
                        // gC񐔈ȓ̏ꍇ
                        if (dwRetry < m_ContextInfo.ComRetryMax) {
                            // gCEFCg
                            wait(m_ContextInfo.RetryWaitTime);
                            // G[l߂
                            dwRet = SW_SUCCESS;
                        }
                    }

                } // gC
            } // 
        } // ubN
    }

    // ̉
    if (NULL != pbFinalFrame) {
        free(pbFinalFrame);
        pbFinalFrame = NULL;
    }

    return dwRet;
}


//-----------------------------------------------------------------------------
// @outline		^[Qbg̎w肳ꂽ̈f[^̃`FbNTEf[^擾đMf[^̃`FbNTEf[^Ɣr܂B
// @explanation	^[Qbg̎w肳ꂽ̈f[^̃`FbNTEf[^擾đMf[^̃`FbNTEf[^Ɣr܂B
// @param		[IN] dwStartAddress `FbNTvZJnAhXw肵܂B
//              [IN] dwEndAddress   `FbNTvZIAhXw肵܂B
//              [OUT]pbCk1          CK1(`FbNTEf[^̉8rbg)i[܂B
//              [OUT]pbCk2          CK2(`FbNTEf[^̏8rbg)i[܂B
//              [IN] fCodeFlash      R[hEtbV̏ꍇ TRUE Af[^EtbV̏ꍇ FALSE w肵܂B
// @return		ɔrłꍇɂ SW_SUCCESS AɔrłȂꍇɂ SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CSequenceProcessor::comChecksum(DWORD dwStartAddress, DWORD dwEndAddress, BYTE* pbCk1, BYTE* pbCk2, BOOL fCodeFlash)
{
    DWORD   dwRet           = SW_SUCCESS;                   // ߂l
    BOOL    fRetry          = FALSE;                        // gCtO
    DWORD   dwRetry         = 0UL;                          // gC
    DWORD   dwCmdLength     = 0UL;                          // R}hEt[̒
    DWORD   dwRecvLen       = 0UL;                          // Mobt@ǂݏoTCY
    DWORD   dwLength        = 0UL;                          // Mobt@ǂݏoTCY
    BYTE    bSal            = 0x00;                         // ݊JnAhX Low    (rbg 7 - rbg 0)
    BYTE    bSam            = 0x00;                         // ݊JnAhX Middle (rbg15 - rbg 8)
    BYTE    bSah            = 0x00;                         // ݊JnAhX High   (rbg23 - rbg16)
    BYTE    bEal            = 0x00;                         // ݏIAhX Low    (rbg 7 - rbg 0)
    BYTE    bEam            = 0x00;                         // ݏIAhX Middle (rbg15 - rbg 8)
    BYTE    bEah            = 0x00;                         // ݏIAhX High   (rbg23 - rbg16)
    DWORD   dwBlockCount    = 0UL;                          // ubN
    DWORD   dwRemainByte    = 0UL;                          // c
    DWORD   dwtCS10         = 0x00;                         // ^CAEg(tCS10)
    DWORD   dwtSD10         = 0x00;                         // ^CAEg(tSD10)

    // R}h
    initCommandInfo(CMD_NUM_CHECKSUM);

    dwBlockCount = (dwEndAddress - dwStartAddress) / BLOCK_SIZE;
    dwRemainByte = (dwEndAddress - dwStartAddress) % BLOCK_SIZE;
    if (0UL < dwRemainByte) {
        dwBlockCount++;
    }

    // ^CAEgԂZbg
    dwtCS10 = m_Wait.GetCheckSumTcs10(fCodeFlash);
    dwtSD10 = m_Wait.GetCheckSumTsd10(dwBlockCount);

    // JnAhX𕪉
    splitAddress(dwStartAddress, &bSah, &bSam, &bSal);
    // IAhX𕪉
    splitAddress(dwEndAddress,   &bEah, &bEam, &bEal);

    for (DWORD i = dwRetry = 0; i < m_ContextInfo.ComRetryMax; i++, dwRetry++) {
        // gC񐔂Zbg
        m_ContextInfo.ComInfo.Retry = i;
        // gCtONA
        fRetry = FALSE;
        // ChecksumR}h̑M
        if (SW_SUCCESS == dwRet) {
            // MOEFCg
            wait(m_ContextInfo.SendWait);

            // ChecksumR}h쐬B
            dwRet = m_Cmd.MakeChecksumCommand(bSal, bSam, bSah, bEal, bEam, bEah, &dwCmdLength);

            // M
            if (SW_SUCCESS == dwRet) {
                dwRet = m_ComPort.SendData(m_Cmd.GetCommandFrames(), dwCmdLength);
            }
        }

        // ChecksumR}hɑ΂Xe[^XEt[̎M҂
        if (SW_SUCCESS == dwRet) {
            dwLength = 0UL;
            dwRet = waitStatusFrames(&dwLength, dwtCS10);
        }

        // ^CAEgȂ烊gCtOZbg
        if (SW_ERROR_RECV_TIMEOUT == dwRet) {
            fRetry = TRUE;
        }

        if (FALSE == fRetry) {
            break;
        }
        else {
            // gCEFCg
            wait(m_ContextInfo.RetryWaitTime);
            // G[l߂
            dwRet = SW_SUCCESS;
        }
    }

    // CehcksumR}hɑ΂Xe[^XEt[̃`FbN
    if (SW_SUCCESS == dwRet) {
        // Mf[^擾
		dwRecvLen = m_ComPort.GetReceivedData(m_Cmd.GetDataFrames(), DAT_FLAME_MAX_SIZE, dwLength);
		
        // ChecksumR}hɑ΂Xe[^XEt[̃`FbN
        if (5UL == dwRecvLen) {
            dwRet = m_Cmd.CheckVerifyStatus(&m_ContextInfo.ComInfo.ST1);
            DTRACE(_T("dwRet = 0x%08X\r\n"), dwRet);
            DTRACE(_T("ST1   = 0x%02X\r\n"), m_ContextInfo.ComInfo.ST1);
		    if (SW_SUCCESS == dwRet) {
			    if (STS_ACK != m_ContextInfo.ComInfo.ST1) {
				    dwRet = SW_ERROR_CMD_STATUS;
			    }
		    }
        }
        else {
            // M^CAEg
    		dwRet = SW_ERROR_RECV_TIMEOUT;
        }
    }

    // CehcksumR}hɑ΂f[^Et[̎M҂
    if (SW_SUCCESS == dwRet) {
        dwLength = 0UL;
        dwRet = waitStatusFrames(&dwLength, dwtSD10);
    }

    if (SW_SUCCESS == dwRet) {
        // Mf[^擾
        dwRecvLen = m_ComPort.GetReceivedData(m_Cmd.GetDataFrames(), DAT_FLAME_MAX_SIZE, dwLength);
		
        // CehcksumR}hɑ΂f[^Et[̃`FbN
        if (6UL == dwRecvLen) {
            dwRet = m_Cmd.CheckChecksumDataFrams(pbCk1, pbCk2);
        }
        else {
            // M^CAEg
    		dwRet = SW_ERROR_RECV_TIMEOUT;
        }
    }

    return dwRet;
}


//-----------------------------------------------------------------------------
// @outline		vO~OE[hւ̑Jڏs܂B
// @explanation	vO~OE[hւ̑Jڏs܂B
// @param		[IN]bBaudRate   {[[glw肵܂B(0x00 = 115,200bps | 0x01 = 250,000bps | 0x02 = 500,000 bps | 0x03 = 1,000,000 bps)
//              [IN]bVoltage    dw肵܂B(:)3.30V -> 33 -> 0x21:dl̏ʂ܂ł̒l16iƂĎw肵܂B)
//              [IN]fInvertDTR  DTRM̏Ԃw肵܂B(TRUE:Invert|FALSE:Normal)
// @return		vO~OE[h֑Jڂłꍇɂ SW_SUCCESS AJڂłȂꍇɂ SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CSequenceProcessor::programingMode(BYTE bBaudRate, BYTE bVoltage, BOOL fInvertDTR)
{
	DWORD	dwRet		= SW_SUCCESS;   // ߂l
    DWORD   dwBaudRate  = 0UL;          // {[[g

    // {[[g`FbN
    switch (bBaudRate) {
    case BPS_115200:
        dwBaudRate = 115200UL;
        break;

    case BPS_250000:
        dwBaudRate = 250000UL;
        break;

    case BPS_500000:
        dwBaudRate = 500000UL;
        break;

    case BPS_1000000:
        dwBaudRate = 1000000;
        break;

    default:
        dwRet = SW_ERROR_PARAMETER;
    }

	if (SW_SUCCESS == dwRet) {
		// [hݏJn
        // Zbg
        if (FALSE == fInvertDTR) {
            m_ComPort.SetDtr();
        }
        else {
		    m_ComPort.ClearDtr();
        }

		// TOOL0Low
		m_ComPort.SetBreak();

		// EFCg
		wait(m_ContextInfo.SendWait);

        // Mobt@̃NA
        m_ComPort.ClearReceiveBuffer();

        // Zbg
        if (FALSE == fInvertDTR) {
            m_ComPort.ClearDtr();
        }
        else {
            m_ComPort.SetDtr();
        }

        // 100msecȓ̏ԑJn
        m_ContextInfo.TransitionStartTime = timeGetTime();

		// Zbg҂
		wait(m_ContextInfo.SendWait);

		// TOOL0High
		m_ComPort.ClearBreak();
		
        // EFCg
        wait(m_ContextInfo.SendWait);

		// [hݒ1oCgf[^M
		BYTE	bModeSetData = { COM_IF_TWO_WIRE }; // 2UART
		dwRet = m_ComPort.SendData(&bModeSetData, sizeof(bModeSetData));
	}

    // BaudRateSetR}h
    if (SW_SUCCESS == dwRet) {
        dwRet = comBaudRateSetProc(bBaudRate, bVoltage);
    }

    // {[[gύX
    if (SW_SUCCESS == dwRet) {
        // ̃{[[gxƈႤꍇ̂ݕύX
        if (dwBaudRate != CBR_115200) {
            dwRet = m_ComPort.ChangeBaudRate(dwBaudRate);
        }
    }

    // ResetR}h
    if (SW_SUCCESS == dwRet) {
        dwRet = comResetProc();
    }

    // SiliconSignatureR}h
    if (SW_SUCCESS == dwRet) {
        dwRet = comSiliconSignatureProc();
    }


 	return dwRet;
}


//-----------------------------------------------------------------------------
// @outline		f[^̎M҂s܂B
// @explanation	f[^̎M҂s܂B
// @param		[out]*dwLength  Mf[^̒i[܂B
//              [in]dwTimeout   ^CAEgԂw肵܂B(msec)
// @return		ɎMłꍇɂ 0 AMłȂꍇɂ 0 ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CSequenceProcessor::waitStatusFrames(DWORD* dwLength, DWORD dwTimeout)
{
    DWORD   dwRet           = SW_SUCCESS;
    DWORD   dwReceiveLength = 0UL;
  	DWORD	dwStartTime     = 0UL;
	DWORD	dwPassTime      = 0UL;
    BYTE    bStx            = 0x00;
    DWORD   dwLen           = 0UL;

    *dwLength = 0UL;

    // JnԂ擾
    dwStartTime = timeGetTime();
    do {
        // Mf[^̃TCY擾B
        dwReceiveLength = m_ComPort.GetReceiveDataLength();

        // 2oCgȏMĂΉ͉\
        if (2 <= dwReceiveLength) {
            // STXLENf[^擾
            dwRet = m_ComPort.CheckDataFrame(&bStx, &dwLen);
            // `FbNSTXf[^̏ꍇ
            if (SW_SUCCESS == dwRet && STX == bStx) {
                // LEN̓e͂t[Ŝ̃TCY擾B
                // LEN̓e + 4oCgiSTXALENASUMAETX or ETBj
                *dwLength = dwLen + 4;
            }
        }

        // oߎԂ擾B
        dwPassTime = timeGetTime() - dwStartTime;

        // ^CAEg
        if (dwPassTime > dwTimeout) {
            dwRet = SW_ERROR_RECV_TIMEOUT;
            break;
        }
      } while (0UL == dwReceiveLength || 
               0UL == *dwLength || 
               *dwLength > dwReceiveLength);

    return dwRet;
}


//-----------------------------------------------------------------------------
// @outline		w肳ꂽԂEFCg܂B
// @explanation	w肳ꂽԂEFCg܂B
// @param		[in]dwMilisecond    EFCgԂw肵܂B(msec)
// @return		ۂɃEFCgԂԂ܂B
//-----------------------------------------------------------------------------
DWORD CSequenceProcessor::wait(DWORD dwMilisecond)
{
#if 0
	Sleep(dwMilisecond);
	return dwMilisecond;
#else
	DWORD	dwStartTime;
	DWORD	dwEndTime;
	DWORD	dwPassTime;

	dwStartTime = timeGetTime();
	do {
		dwEndTime = timeGetTime();
	} while (dwPassTime = (dwEndTime - dwStartTime) <= dwMilisecond);

	return dwPassTime;
#endif
}


//-----------------------------------------------------------------------------
// @outline	    AhXl쐬܂B
// @explanation	AhXl쐬܂B
// @param		[in]bHigh    AhXHighw肵܂Birbg23 - rbg16j
//      		[in]bMid     AhXHighw肵܂Birbg15 - rbg 8j
//      		[in]bLow     AhXHighw肵܂Birbg 7 - rbg 0j
// @return		쐬AhXlԂ܂B
//-----------------------------------------------------------------------------
DWORD CSequenceProcessor::makeAddress(BYTE bHigh, BYTE bMid, BYTE bLow)
{
	return ((DWORD) bLow << 16) | ((DWORD) bMid << 8) | bHigh;
}


//-----------------------------------------------------------------------------
// @outline	    AhXl𕪉܂B
// @explanation	AhXl𕪉܂B
// @param		[in]address     AhXw肵܂B
//              [out]pbHigh     AhXHighi[܂Birbg23 - rbg16j
//      		[out]pbMid      AhXHighi[܂Birbg15 - rbg 8j
//      		[out]pbLow      AhXHighi[܂Birbg 7 - rbg 0j
// @return		ɐꍇɂ 0 A sꍇɂ 0 ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CSequenceProcessor::splitAddress(DWORD address, BYTE* pbHigh, BYTE* pbMid, BYTE* pbLow)
{
    DWORD   dwRet = SW_SUCCESS;

    *pbHigh  = (BYTE)((address & 0x00FF0000) >> 16);
    *pbMid   = (BYTE)((address & 0x0000FF00) >>  8);
    *pbLow   = (BYTE)((address & 0x000000FF));

    return dwRet;
}


//-----------------------------------------------------------------------------
// @outline	    t@[EFÃo[Wl쐬܂B
// @explanation	AhXl쐬܂B
// @param		[in]bMajor  W[ԍw肵܂B
//      		[in]bMinor  }Ci[ԍw肵܂B
//      		[in]bBuild  rhԍw肵܂B
// @return		쐬t@[EFÃo[WlԂ܂B
//-----------------------------------------------------------------------------
FLOAT CSequenceProcessor::makeFirmWareVersion(BYTE bMajor, BYTE bMinor, BYTE bBuild)
{
    if (0x00 == bMajor &&
        0x00 == bMinor &&
        0x00 == bBuild) {

        return 0.0F;
    }
    else {
        return (((WORD) bMajor * 100) + ((WORD) bMinor * 10) + ((WORD) bBuild)) / 100.0F;    
    }
}


//-----------------------------------------------------------------------------
// @outline	    R}h܂B
// @explanation	R}h܂B
// @param		[in]bCommand    R}hԍw肵܂B
// @return		none
//-----------------------------------------------------------------------------
void CSequenceProcessor::initCommandInfo(BYTE bCommand)
{
    m_ContextInfo.ComInfo.Command   = bCommand;
    m_ContextInfo.ComInfo.ST1       = 0x00;
    m_ContextInfo.ComInfo.DST1      = 0x00;
    m_ContextInfo.ComInfo.DST2      = 0x00;
    m_ContextInfo.ComInfo.Retry     = 0UL;
}


//-----------------------------------------------------------------------------
// @outline	    TCYƃAhX͈̔͂`FbN܂B
// @explanation	TCYƃAhX͈̔͂`FbN܂B
// @param		[IN]dwProgramStartAddress   R[hEtbV̊JnAhXw肵܂B
//              [IN]dwProgramSize           R[hEtbṼTCYw肵܂B
//              [IN]dwDataStartAddress      f[^EtbV̊JnAhXw肵܂B
//              [IN]dwDataSize              f[^EtbṼTCYw肵܂B
// @return		͈͓ł SW_SUCCESS  ͈͊Oł SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CSequenceProcessor::checkSizeAndAddressRange(DWORD dwProgramStartAddress, DWORD dwProgramSize, DWORD dwDataStartAddress, DWORD dwDataSize)
{
    DWORD   dwRet               = SW_SUCCESS;       // ߂l
    DWORD   dwCfStartAddress    = CF_START_ADDRESS; // R[hEtbVE̊JnAhX
    DWORD   dwCfEndAddress      = 0UL;              // R[hEtbVE̍ŏIAhX
    DWORD   dwCfSize            = 0UL;              // R[hEtbVEԂ̃TCY
    DWORD   dwDfStartAddress    = DF_START_ADDRESS; // f[^EtbVE̊JnAhX
    DWORD   dwDfEndAddress      = 0UL;              // f[^EtbVE̍ŏIAhX
    DWORD   dwDfSize            = 0UL;              // f[^EtbVEԂ̃TCY
    
    // SiliconSignatureŎ擾CEN̍ŏIAhX擾
    dwCfEndAddress = makeAddress(m_ContextInfo.SiliconSignature.CodeEndAddress[0],
                                m_ContextInfo.SiliconSignature.CodeEndAddress[1],
                                m_ContextInfo.SiliconSignature.CodeEndAddress[2]);
    
    // R[hEtbVEԂ̃TCY擾
    dwCfSize = dwCfEndAddress + 1 - dwCfStartAddress;

    // SiliconSignatureŎ擾DEN̍ŏIAhX擾
    dwDfEndAddress = makeAddress(m_ContextInfo.SiliconSignature.DataEndAddress[0],
                                m_ContextInfo.SiliconSignature.DataEndAddress[1],
                                m_ContextInfo.SiliconSignature.DataEndAddress[2]);

    // MEMO:DEN̍ŏIAhX0x000000ł΃f[^EtbVE񓋍ڕi
    if (0UL == dwDfEndAddress) {
        dwDfSize = 0UL;
    }
    else {
        dwDfSize = dwDfEndAddress + 1 - dwDfStartAddress;
    }

    // `FbN
    
    if (SW_SUCCESS == dwRet) {
        // R[hEtbVẼTCY`FbN
        if (dwCfSize >= dwProgramSize) {
            // R[hEtbVE̊JnAhX̃`FbN
            if (dwCfStartAddress < dwProgramStartAddress &&
                0UL == (dwProgramStartAddress % BLOCK_SIZE)) {
                    // JnAhXs
                    dwRet = SW_ERROR_CF_START_ADDRESS;
            } 
        }
        else {
            // TCYs
            dwRet = SW_ERROR_CF_SIZE;
        }
    }

    if (SW_SUCCESS == dwRet) {
        // f[^EtbVẼTCY`FbN
        if (dwDfSize >= dwDataSize) {
            // f[^EtbVE̊JnAhX̃`FbN
            if (dwDfStartAddress < dwDataStartAddress &&
                0UL == (dwDataStartAddress % BLOCK_SIZE)) {
                // JnAhXs
                dwRet = SW_ERROR_DF_START_ADDRESS;
            }
        }
        else {
            // TCYs
            dwRet = SW_ERROR_DF_SIZE;
        }
    }

    return dwRet;
}


//-----------------------------------------------------------------------------
// @outline	    `FbNT擾܂B
// @explanation	`FbNT擾܂B
// @param		[IN] pbData     Mf[^̃|C^w肵܂B
//              [IN] dwSize     Mf[^̃TCYw肵܂B
//              [OUT]checksum   擾`FbNTi[܂B
// @return		`FbNT擾łꍇɂ SW_SUCCESS  擾łȂꍇɂ SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CSequenceProcessor::getChecksum(BYTE* pbData, DWORD dwSize, WORD* checksum)
{
    DWORD   dwRet           = SW_SUCCESS;   // ߂l
    DWORD   dwBlockCount    = 0UL;          // ubN
    DWORD   dwRemainByte    = 0UL;          // c
    DWORD   dwDummySize     = 0UL;          // _~[

    // NA
    *checksum = 0UL;

    // ubNƎc擾
    dwBlockCount = dwSize / BLOCK_SIZE;
    dwRemainByte = dwSize % BLOCK_SIZE;
    
    // ubÑ`FbNTZo
    for (DWORD i = 0; i < dwBlockCount; i++) {
        for (DWORD j = 0; j < BLOCK_SIZE; j++) {
            *checksum -= pbData[(i * BLOCK_SIZE) + j];
        }
    }

    // cƃ_~[̃`FbNTZo
    if (0UL < dwRemainByte) {
        dwDummySize  = BLOCK_SIZE - dwRemainByte;

        // c̃`FbNTZo
        for (DWORD i = 0; i < dwRemainByte; i++) {
            *checksum -= pbData[(dwBlockCount * BLOCK_SIZE) + i];
        }

        // _~[̃`FbNTZo
        for (DWORD i = 0; i < dwDummySize; i++) {
            *checksum -= DUMMY_BYTE;
        }
    }

    return dwRet;
}

//-----------------------------------------------------------------------------
// @outline	    eLXg{bNXւ̃Oo͂s܂B
// @explanation	eLXg{bNXւ̃Oo͂s܂B
// @param		[IN] o̓bZ[W
// @return		
//-----------------------------------------------------------------------------
void CSequenceProcessor::putUpdateLog(wstring format,...)
{
    TCHAR buf[2048];
    va_list ap;

    // tH[}bg̐
    va_start(ap, format);
    wvsprintf(buf, &format[0], ap);
    va_end(ap);

    // F/WXVO̕\
    SendMessage(m_ContextInfo.UpdateLog, EM_REPLACESEL, 0, (LPARAM)buf);
    // F/WXVÕXN[
    SendMessage(m_ContextInfo.UpdateLog, WM_VSCROLL, SB_BOTTOM, NULL);
}

//-----------------------------------------------------------------------------
// @outline	    ʂ擾܂
// @explanation	ʂ擾܂B
// @param		[IN] 
// @return		ʂɉbZ[W
//-----------------------------------------------------------------------------
wstring CSequenceProcessor::getResultText(DWORD result)
{
	wstring msg;

	switch(result) {
	case SW_SUCCESS:
		msg = _T(" OK\r\n");
		break;

	// nG[n
	case SW_ERROR_SERIAL_INFO:
		msg = _T(" Error\r\nG[FVA|[g̎擾s\r\n");
		break;
	case SW_ERROR_SERIAL_UNSELECT:
		msg = _T(" Error\r\nG[FVA|[gI\r\n");
		break;
	case SW_ERROR_SERIAL_OPEN:
		msg = _T(" Error\r\nG[FVA|[g̃I[vG[\r\n");
		break;
	case SW_ERROR_CHG_EEPROM:
		msg = _T(" Error\r\nG[FEEPROM̕ύXs\r\n");
		break;

	// nG[n
	case SW_ERROR_INIT:
		msg = _T(" Error\r\nG[Fs\r\n");
		break;
	case SW_ERROR_FRAME_FORMAT:
		msg = _T(" Error\r\nG[Ft[tH[}bgs\r\n");
		break;
	case SW_ERROR_PARAMETER:
		msg = _T(" Error\r\nG[Fp[^s\r\n");
		break;
	case SW_ERROR_CHECKSUM:
		msg = _T(" Error\r\nG[FSUMs\r\n");
		break;
	case SW_ERROR_SEND_DATA:
		msg = _T(" Error\r\nG[FMs\r\n");
		break;
	case SW_ERROR_RECV_TIMEOUT:
		msg = _T(" Error\r\nG[FM^CAEg\r\n");
		break;
	case SW_ERROR_SEND_TIMEOUT:
		msg = _T(" Error\r\nG[FM^CAEg\r\n");
		break;
	case SW_ERROR_CMD_STATUS:
		msg = _T(" Error\r\nG[FR}hEt[ɑ΂ُI\r\n");
		break;
	case SW_ERROR_DATA_STATUS:
		msg = _T(" Error\r\nG[Ff[^Et[ɑ΂ُI\r\n");
		break;
	case SW_ERROR_MODE_CHANGE_TIMEOUT:
		msg = _T(" Error\r\nG[F[hݏ̃^CAEg\r\n");
		break;
	case SW_ERROR_NO_BRANK:
		msg = _T(" Error\r\nG[FuNł͂Ȃ\r\n");
		break;
	case SW_ERROR_CHG_BAUDRATE:
		msg = _T(" Error\r\nG[F{[[gύXs\r\n");
		break;
	case SW_ERROR_BUFFER_OVER_FLOW:
		msg = _T(" Error\r\nG[Fobt@[I[o[t[\r\n");
		break;
	case SW_ERROR_CHECKSUM_CMD:
		msg = _T(" Error\r\nG[FCehcksumR}hŎ擾lGUIŎZolقȂ\r\n");
		break;

	// t@CI/OnG[
	case SW_ERROR_FIO_NOT_FOUND:
		msg = _T(" Error\r\nG[Ft@C݂܂B\r\n");
		break;
	case SW_ERROR_FIO_INVALID_TYPE:
		msg = _T(" Error\r\nG[FΉ`\r\n");
		break;
	case SW_ERROR_FILE_SIZE:
		msg = _T(" Error\r\nG[Ft@C̃TCYsłB\r\n");
		break;
	case SW_ERROR_FILE_READ:
		msg = _T(" Error\r\nG[Ft@C̓ǂ݂݂Ɏs܂B\r\n");
		break;
	case SW_ERROR_CF_SIZE:
		msg = _T(" Error\r\nG[FR[hEtbVẼTCYs\r\n");
		break;
	case SW_ERROR_DF_SIZE:
		msg = _T(" Error\r\nG[Ff[^EtbVẼTCYs\r\n");
		break;

	case SW_ERROR_CF_START_ADDRESS:
		msg = _T(" Error\r\nG[FR[hEtbVE̊JnAhXs\r\n");
		break;
	
	case SW_ERROR_DF_START_ADDRESS:
		msg = _T(" Error\r\nG[Ff[^EtbVE̊JnAhXs\r\n");
		break;

	default:
		msg = _T(" Error\r\nG[FsȃG[܂\r\n");
		break;
	}

	return msg;
}