/*
 * Copyright (c) 2012,2015 Renesas Electronics Corporation and TESSERA
 * TECHNOLOGY INC.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

//=============================================================================
// FileName : SequenceProcessor.h
//=============================================================================
#pragma once

//=============================================================================
// CN[h
//=============================================================================
#include "SerialPortProcessor.h"
#include "Common.h"
#include "CommandProcessor.h"
#include "TargetFile.h"
#include "WaitingTimeCalculator.h"
#include <MMSystem.h>

//=============================================================================
// N
//=============================================================================
#pragma comment(lib, "winmm.lib") // for }`EfBAE^C}

//=============================================================================
// 萔`
//=============================================================================
#if 0
#define CF_START_ADDRESS                (0UL)                       // R[hEtbVEJnAhX
#define DF_START_ADDRESS                (0xF1000)                   // f[^EtbVEJnAhX

#define PROC_TIME_FLG                   (TRUE)                      // vtO(TRUE:v | FALSE:vȂ)
#endif


//=============================================================================
// \̐錾
//=============================================================================
#if 0	// common.hֈړ
//-----------------------------------------------------------------------------
// ii[܂B
//-----------------------------------------------------------------------------
typedef struct _PROGRESSINIFO {
    DWORD   Step;               // Xebv
    DWORD   CurrentProgress;    // ݒl
    DOUBLE  Share;              // Ŝɑ΂銄
    DWORD   InitProgress;       // l
    DOUBLE  Incremental;        // l
} PROGRESSINIFO, *PPROGRESSINIFO, *LPPROGRESSINIFO;
#endif 

//=============================================================================
// NX`
//=============================================================================
//-----------------------------------------------------------------------------
// @outline		CSequenceProcessor NX
// @explanation	sNXłB
//-----------------------------------------------------------------------------
class CSequenceProcessor
{
public:
	// RXgN^
	CSequenceProcessor(void);
	// fXgN^
	~CSequenceProcessor(void);

	// s܂B
	DWORD	Initialize();

    // F/W̏Jn܂B
    DWORD   Start(CONTEXTINFO contextInfo);

private:
    // ReLXg
    CONTEXTINFO             m_ContextInfo;
    
    // Xbh̃nh 
    HANDLE                  m_hThread;
	
    // Xbh̃XbhID 
    DWORD                   m_dwThreadId;
	
    // ^C}̕\
	TIMECAPS				m_Timecaps;
	
	// VAE|[gENX
	CSerialPortProcessor	m_ComPort;
	
    // R}hNX
	CCommandProcessor		m_Cmd;

    // ^[QbgEt@CNX
    CTargetFile             m_TargetFile;

    // ҂ԌvZNX
    CWaitingTimeCalculator  m_Wait;

    // i\
    PROGRESSINIFO           m_Progress;

    // vO~OXbh֐擾܂B
    static DWORD	WINAPI getThreadFunc(LPVOID lpvParametr); 
    
    // vO~Os܂B
    DWORD			WINAPI programming();

   	// vO~OE[hւ̑Jڏs܂B
    DWORD	programingMode(BYTE bBaudRate, BYTE bVoltage, BOOL fInvertDTR);

    // iXV܂B
    LRESULT UpdateProgress(DWORD dwStep, DWORD dwPercentage);

    // UARTʐMݒ̃{[E[gݒ肨ѓdݒf[^̐ݒs܂B
    DWORD comBaudRateSetProc(BYTE bBaudRate, BYTE bVoltage);

    // ύX{[E[gł̓mFs܂B
    DWORD comResetProc();

    // RL78ȉiVREVOl`jǂݏo܂B
    DWORD comSiliconSignatureProc();
    
    // w肵ubN܂B
    DWORD comBlockEraseProc(DWORD dwStartAddress, BOOL fCodeFlash);

    // RL78ɐݒ肳ĂZLeB擾܂B
    DWORD comSecrityGetProc();

    // w肵ubNuNł邩`FbN܂B
    DWORD comBlockBlankCheckProc(DWORD dwStartAddress, BOOL fCodeFlash);

    // [UEvO~OtbVEɏ݂܂B
    DWORD comProgrammingProc(DWORD dwStartAddress, DWORD dwEndAddress, BYTE* pbData, DWORD dwDataLength, BOOL fCodeFlash);

    // ^[Qbg̎w肳ꂽ̈f[^̃`FbNTEf[^擾܂B
    DWORD comChecksum(DWORD dwStartAddress, DWORD dwEndAddress, BYTE* pbCk1, BYTE* pbCk2, BOOL fCodeFlash);

    // f[^̎M҂s܂B
    DWORD waitStatusFrames(DWORD* dwLength, DWORD dwTimeout);

    // w肳ꂽԂEFCg܂B
    DWORD	wait(DWORD dwMilisecond);

    // AhXl쐬܂B
    inline DWORD makeAddress(BYTE bHigh, BYTE bMid, BYTE bLow);

    // AhXl𕪉܂B
    inline DWORD splitAddress(DWORD address, BYTE* pbHigh, BYTE* pbMid, BYTE* pbLow);

    // t@[EFÃo[Wl쐬܂B
    inline FLOAT makeFirmWareVersion(BYTE bMajor, BYTE bMinor, BYTE bBuild);

    // R}h܂B
    void initCommandInfo(BYTE bCommand);

    // TCYƃAhX͈̔͂`FbN܂B
    DWORD checkSizeAndAddressRange(DWORD dwProgramStartAddress, DWORD dwProgramSize, DWORD dwDataStartAddress, DWORD dwDataSize);

    // `FbNT擾܂B
    DWORD getChecksum(BYTE* pbData, DWORD dwSize, WORD* checksum);

    // F/WXVOo͂܂B
    void putUpdateLog(wstring format,...);

	// ʂɉbZ[W擾܂B
	wstring getResultText(DWORD result);

#if _DEBUG
    // fobOF[h݌
    void DEBUG_MODE_RESULT(DWORD dwRet);

    // fobOFs
    void DEBUG_RESULT(DWORD dwRet, DWORD dwPassTime);
#endif
};
