/*
 * Copyright (c) 2012,2015 Renesas Electronics Corporation and TESSERA
 * TECHNOLOGY INC.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

//=============================================================================
// CTargetFile NX
//=============================================================================
#include "TargetFile.h"


//-----------------------------------------------------------------------------
// @outline		RXgN^
// @explanation	RXgN^
// @param		none
// @return		none
//-----------------------------------------------------------------------------
CTargetFile::CTargetFile(void) 
    : m_pbProgram(NULL), m_dwProgramSize(0UL),
      m_pbData(NULL), m_dwDataSize(0UL),
      m_EInputFile(CTargetFile::Unknown)
{

}


//-----------------------------------------------------------------------------
// @outline		fXgN^
// @explanation	fXgN^
// @param		none
// @return		none
//-----------------------------------------------------------------------------
CTargetFile::~CTargetFile(void)
{
	releaseData();
}


//-----------------------------------------------------------------------------
// @outline     mۂ̈f[^܂B
// @explanation mۂ̈f[^܂B
// @param       none
// @return      none
//-----------------------------------------------------------------------------
void CTargetFile::releaseData()
{
    // vÖf[^̉
	if (NULL != m_pbProgram) {
		free(m_pbProgram);
		m_pbProgram = NULL;
	}

    // vOË̃TCYNA
    m_dwProgramSize = 0UL;

    // f[^̈f[^̉
    if (NULL != m_pbData) {
        free(m_pbData);
        m_pbData = NULL;
    }

    // f[^EtbV̈̃TCYNA
    m_dwDataSize = 0UL;
}


//-----------------------------------------------------------------------------
// @outline     w肵t@Cǂݍ݂܂B
// @explanation w肵t@Cǂݍ݂܂B
// @param       [IN]szFilePathName  ǂݍރt@C̃tpXw肵܂B
// @return      ɓǂݍ݂łꍇɂ SW_SUCCESS Aɓǂݍ݂łȂꍇɂ SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CTargetFile::ReadFile(TCHAR  *szFilePathName)
{
	DWORD	dwRet       = SW_SUCCESS;   // ߂l

    TCHAR   szDrv       [MAX_PATH];     // hCu
    TCHAR   szDir       [MAX_PATH];     // fBNg
    TCHAR   szFileName  [MAX_PATH];     // t@C
    TCHAR   szExtension [MAX_PATH];     // gq
    

    // t@C̑݊mF
    if (TRUE  == PathFileExists(szFilePathName) &&
        FALSE == PathIsDirectory(szFilePathName)) {
            // t@CpX𕪉
            _tsplitpath_s(szFilePathName, 
                          szDrv, 
                          szDir, 
                          szFileName,
                          szExtension);
    }
    else {
        // t@C݂ȂB
        dwRet = SW_ERROR_FIO_NOT_FOUND;
    }

    if (SW_SUCCESS == dwRet) {
        // gqŃt@C̎ނ𔻕ʂB
        if (0 == _tcsicmp(_T(".bin"), szExtension)) {
            // oCit@C̏ꍇ
            m_EInputFile = CTargetFile::Bin;
            dwRet = readFromBinFile(szFilePathName);
        }
        else {
            // `t@C̏ꍇ̓G[
            m_EInputFile = CTargetFile::Unknown;
            dwRet = SW_ERROR_FIO_INVALID_TYPE;
        }
    }

    return dwRet;
}


//-----------------------------------------------------------------------------
// @outline     w肵t@CoCi`Ƃēǂݍ݂܂B
// @explanation w肵t@CoCi`Ƃēǂݍ݂܂B
// @param       [IN]szFilePathName  ǂݍރt@C̃tpXw肵܂B
// @return      ɓǂݍ݂łꍇɂ SW_SUCCESS Aɓǂݍ݂łȂꍇɂ SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CTargetFile::readFromBinFile(TCHAR *szFilePathName)
{
	DWORD		dwRet       = SW_SUCCESS;               // ߂l
	ULONGLONG	ulFileSize  = 0UL;                      // t@C̃TCY
    HANDLE      hFile       = INVALID_HANDLE_VALUE;     // t@C̃nh

    // wt@CJB
    hFile = CreateFile( szFilePathName, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
    if( INVALID_HANDLE_VALUE == hFile) {
   		// t@C̓ǍɎs
		dwRet = SW_ERROR_FILE_READ;
    }

    if (SW_SUCCESS == dwRet) {
        ulFileSize = GetFileSize(hFile, NULL);
        if (0UL >= ulFileSize || 
            MAX_BIN_FILE_SIZE < ulFileSize) {
            // t@CTCYs
            dwRet = SW_ERROR_FILE_SIZE;
        }
    }

	// m
    if (SW_SUCCESS == dwRet) {
	    // Kvł΃
		releaseData();
		
        // t@CTCYm
        m_pbProgram = (BYTE*)malloc((UINT)ulFileSize);
		if (m_pbProgram == NULL) {
			// t@C̓ǍɎs
			dwRet = SW_ERROR_FILE_READ;
		}
	}

	// Ǎ
	if (SW_SUCCESS == dwRet) {
        DWORD   dwReadBytes = 0UL;
        // xɑSǂݍ
        if (FALSE != ::ReadFile(hFile, m_pbProgram, (DWORD)ulFileSize, &dwReadBytes, NULL)) {
            // ǂݍ݃TCỸ`FbN
            if (dwReadBytes == ulFileSize) {
                // ǂݍ񂾃TCYێ
                m_dwProgramSize = dwReadBytes;
            }
            else {
                // t@C̓ǍɎs
			    dwRet = SW_ERROR_FILE_READ;
            }
        }
        else {
            // t@C̓ǍɎs
			dwRet = SW_ERROR_FILE_READ;
        }
	}

	// t@CB
    if( INVALID_HANDLE_VALUE != hFile) {
        CloseHandle(hFile);
    }

    if (SW_SUCCESS != dwRet) {
        // ܂ł̏ŃG[̏ꍇ̓B
        releaseData();
    }

	return dwRet;
}
