/*
 * Copyright (c) 2012,2015 Renesas Electronics Corporation and TESSERA
 * TECHNOLOGY INC.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

//=============================================================================
// FileName : TargetFile.h
//=============================================================================
#pragma once

//=============================================================================
// CN[h
//=============================================================================
#include "stdwin.h"
#include "Common.h"
#include <Shlwapi.h>

//=============================================================================
// N
//=============================================================================
#pragma comment(lib, "shlwapi.lib")

//=============================================================================
// 萔`
//=============================================================================
#define MAX_BIN_FILE_SIZE               (1024 * 256)

//=============================================================================
// NX`
//=============================================================================
//-----------------------------------------------------------------------------
// @outline		CTargetFile NX
// @explanation	^[Qbgt@C𑀍삷NXłB
//-----------------------------------------------------------------------------
class CTargetFile
{
public:
    // ͂t@C̎ނʂ܂B
    enum EInputFile {
	    Unknown = 0,    // `
        Bin = 1,        // oCi`
	    Hex = 2,        // wLT`
    };

    // RXgN^
	CTargetFile(void);

    // fXgN^
	~CTargetFile(void);

    // t@C̎ނ擾܂B
    EInputFile  GetFileType() { return m_EInputFile; };

    // vOË̃f[^擾܂B
    BYTE*       GetProgramMemory()  { return m_pbProgram; };

    // vOË̃TCY擾܂B
    DWORD       GetProgramMemorySize()    { return m_dwProgramSize; };

    // f[^EtbV̈̃f[^擾܂B
    BYTE*       GetDataFlash()      { return m_pbData; };

    // f[^EtbV̈̃TCY擾܂B
    DWORD       GetDataSize()       { return m_dwDataSize; };

    // w肵t@Cǂݍ݂܂B
    DWORD		ReadFile(TCHAR *szFilePathName);


private:
	
    // vOËf[^
    BYTE*		m_pbProgram;

    // vOË̃TCY
    DWORD       m_dwProgramSize;

    // f[^EtbV̈f[^
    BYTE*       m_pbData;

    // f[^EtbV̈̃TCY
    DWORD       m_dwDataSize;
	
    // t@C̎
    EInputFile  m_EInputFile;

    // mۂ̈f[^܂B
	void		releaseData();

    // w肵t@CoCi`Ƃēǂݍ݂܂B
	DWORD		readFromBinFile(TCHAR *szFilePathName);
};

