/*
 * Copyright (c) 2012,2015 Renesas Electronics Corporation and TESSERA
 * TECHNOLOGY INC.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

//=============================================================================
// CTargetFileForMot NX
//=============================================================================
#include <fstream>
#include <iostream>
#include <string>

#include "TargetFileForMot.h"


//-----------------------------------------------------------------------------
// @outline		RXgN^
// @explanation	RXgN^
// @param		none
// @return		none
//-----------------------------------------------------------------------------
CTargetFileForMot::CTargetFileForMot(void) 
    : m_pbProgram(NULL), m_dwProgramSize(0UL),
      m_pbData(NULL), m_dwDataSize(0UL),
	  m_VerboseLevel(0UL),
      m_EInputFile(CTargetFileForMot::Unknown)
{
}


//-----------------------------------------------------------------------------
// @outline		fXgN^
// @explanation	fXgN^
// @param		none
// @return		none
//-----------------------------------------------------------------------------
CTargetFileForMot::~CTargetFileForMot(void)
{
	releaseData();
}


//-----------------------------------------------------------------------------
// @outline     mۂ̈f[^܂B
// @explanation mۂ̈f[^܂B
// @param       none
// @return      none
//-----------------------------------------------------------------------------
void CTargetFileForMot::releaseData()
{
    // vÖf[^̉
	if (NULL != m_pbProgram) {
		free(m_pbProgram);
		m_pbProgram = NULL;
	}

    // vOË̃TCYNA
    m_dwProgramSize = 0UL;

    // f[^̈f[^̉
    if (NULL != m_pbData) {
        free(m_pbData);
        m_pbData = NULL;
    }

    // f[^EtbV̈̃TCYNA
    m_dwDataSize = 0UL;
}


#if 0
//-----------------------------------------------------------------------------
// @outline     w肵t@Cǂݍ݂܂B
// @explanation w肵t@Cǂݍ݂܂B
// @param       [IN]szFilePathName  ǂݍރt@C̃tpXw肵܂B
// @return      ɓǂݍ݂łꍇɂ SW_SUCCESS Aɓǂݍ݂łȂꍇɂ SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CTargetFileForMot::ReadFile(TCHAR  *szFilePathName)
{
	DWORD	dwRet       = SW_SUCCESS;   // ߂l

    TCHAR   szDrv       [MAX_PATH];     // hCu
    TCHAR   szDir       [MAX_PATH];     // fBNg
    TCHAR   szFileName  [MAX_PATH];     // t@C
    TCHAR   szExtension [MAX_PATH];     // gq
    

    // t@C̑݊mF
    if (TRUE  == PathFileExists(szFilePathName) &&
        FALSE == PathIsDirectory(szFilePathName)) {
            // t@CpX𕪉
            _tsplitpath_s(szFilePathName, 
                          szDrv, 
                          szDir, 
                          szFileName,
                          szExtension);
    }
    else {
        // t@C݂ȂB
        dwRet = SW_ERROR_FIO_NOT_FOUND;
    }

    if (SW_SUCCESS == dwRet) {
        // gqŃt@C̎ނ𔻕ʂB
        if (0 == _tcsicmp(_T(".mot"), szExtension)) {
            // oCit@C̏ꍇ
            m_EInputFile = CTargetFileForMot::Bin;
            dwRet = readFromBinFile(szFilePathName);
        }
        else {
            // `t@C̏ꍇ̓G[
            m_EInputFile = CTargetFileForMot::Unknown;
            dwRet = SW_ERROR_FIO_INVALID_TYPE;
        }
    }

    return dwRet;
}
#endif

//-----------------------------------------------------------------------------
// @outline     w肵Mott@C̃TCYZo܂B
// @explanation w肵Mott@C̃TCYZo܂B
// @param       [IN]szFilePathName  ΏMOTt@C̃tpXw肵܂B
// @return      ɓǂݍ݂łꍇɂ SW_SUCCESS Aɓǂݍ݂łȂꍇɂ SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CTargetFileForMot::MotFileSize(TCHAR* filename)
{
	std::ifstream ifs(filename);
	std::string line;
    
    int rc = SW_SUCCESS;

    
	if (ifs.fail())
    {
        return SW_ERROR_FILE_READ;
    }

	m_dwProgramSize = 0;
	m_dwDataSize = 0;

	ifs.seekg(0, ios_base::beg);

    while (getline(ifs, line))
    {
		if ('S' != line[0])
        {
            rc = SW_ERROR_FIO_INVALID_TYPE;
            break;
        }

        // Ignore non-data frames
        DWORD record_type = ascii2hex(&line[1], 1);
        if (1 != record_type
            && 2 != record_type
            && 3 != record_type)
        {
			continue;
        }       

		const int address_length = (record_type + 1) * 2; // in symbols
        unsigned int address = ascii2hex(&line[4], address_length);
        const int data_length = ascii2hex(&line[2], 2) - address_length / 2 - 1; // in bytes
 		unsigned int endAddress = address + data_length;

		// f[^̈ʒumF
		if( endAddress < DF_START_ADDRESS )
		{
			// ΏۃAhXf[^̈JnW菬ꍇ

			// ݕێĂvÖ̍Ō傢AhXĂꍇ
			if( endAddress > m_dwProgramSize )
			{
				// vÖ̃TCYXV
				m_dwProgramSize = endAddress;
			}
		}
		else
		{
			// ΏۃAhXf[^̈JnW傫ꍇ
			
			// ݕێĂf[^̈̍Ō傢AhXĂꍇ
			if( endAddress > m_dwDataSize )
			{
				// vÖ̃TCYXV
				m_dwDataSize = endAddress;
			}

		}
	}

	// ϊɎsꍇ́uΉ`vG[Ԃ
	if( m_dwProgramSize <= 0 &&m_dwDataSize <= 0){
		rc = SW_ERROR_FIO_INVALID_TYPE;
	}

	ifs.close();
    return rc;


}

//-----------------------------------------------------------------------------
// @outline     w肵t@Cǂݍ݂܂B
// @explanation w肵t@Cǂݍ݂܂B
// @param       [IN]szFilePathName  ǂݍރt@C̃tpXw肵܂B
// @return      ɓǂݍ݂łꍇɂ SW_SUCCESS Aɓǂݍ݂łȂꍇɂ SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CTargetFileForMot::ReadFile(TCHAR* filename)
{
    int rc = SW_SUCCESS;
	
	// f[^̎󂯎M쐬
	releaseData();

	// f[^͂AKvȃ̈Zo
	rc = MotFileSize(filename); 
	if( rc != SW_SUCCESS )
	{
		return rc;
	}

	std::ifstream ifs(filename);
	std::string line;

	if (ifs.fail())
    {
        return SW_ERROR_FILE_READ;
    }

	m_pbProgram = (BYTE*)malloc((UINT)m_dwProgramSize);
	memset(m_pbProgram, 0xFF, m_dwProgramSize);
	m_pbData = (BYTE*)malloc((UINT)m_dwDataSize); 
	memset(m_pbData, 0xFF, m_dwDataSize);

	ifs.seekg(0, ios_base::beg);

    while (getline(ifs, line))
    {
        if ('S' != line[0])
        {
            rc = SW_ERROR_FIO_INVALID_TYPE;
            break;
        }
        // Ignore non-data frames
        DWORD record_type = ascii2hex(&line[1], 1);
        if (1 != record_type
            && 2 != record_type
            && 3 != record_type)
        {
            continue;
        }       

		const int address_length = (record_type + 1) * 2; // in symbols
        unsigned int address = ascii2hex(&line[4], address_length);
        const int data_length = ascii2hex(&line[2], 2) - address_length / 2 - 1; // in bytes
        const char *data_p = &line[0] + 4 + address_length;
        unsigned char *memory;

		DTRACE(_T("Mot Address = %08X, Length = %08X\r\n"), address, data_length );

        if ((CF_START_ADDRESS + m_dwProgramSize) >= (address + data_length))
        {
            if (NULL == m_pbProgram)
            {
                continue;
            }
            memory = (unsigned char*)m_pbProgram;
            address -= CF_START_ADDRESS;
        }
        else if (DF_START_ADDRESS <= address
            && (DF_START_ADDRESS + m_dwDataSize) > (address + data_length))
        {
            if (NULL == m_pbData)
            {
                continue;
            }
            memory = (unsigned char*)m_pbData;
            address -= DF_START_ADDRESS;
         }
        else
        {
            rc = SW_ERROR_DF_SIZE;
            break;
        }
        unsigned int i = data_length;
        for(; 0 < i; --i)
        {
            memory[address] = ascii2hex(data_p, 2);
            ++address;
            data_p += 2;
        }
    }

	ifs.close();
  
    return rc;
}

//-----------------------------------------------------------------------------
// @outline     w肵t@CoCi`Ƃēǂݍ݂܂B
// @explanation w肵t@CoCi`Ƃēǂݍ݂܂B
// @param       [IN]szFilePathName  ǂݍރt@C̃tpXw肵܂B
// @return      ɓǂݍ݂łꍇɂ SW_SUCCESS Aɓǂݍ݂łȂꍇɂ SW_SUCCESS ȊOԂ܂B
//-----------------------------------------------------------------------------
DWORD CTargetFileForMot::readFromBinFile(TCHAR *szFilePathName)
{
	DWORD		dwRet       = SW_SUCCESS;               // ߂l
	ULONGLONG	ulFileSize  = 0UL;                      // t@C̃TCY
    HANDLE      hFile       = INVALID_HANDLE_VALUE;     // t@C̃nh

    // wt@CJB
    hFile = CreateFile( szFilePathName, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
    if( INVALID_HANDLE_VALUE == hFile) {
   		// t@C̓ǍɎs
		dwRet = SW_ERROR_FILE_READ;
    }

    if (SW_SUCCESS == dwRet) {
        ulFileSize = GetFileSize(hFile, NULL);
        if (0UL >= ulFileSize || 
            MAX_BIN_FILE_SIZE < ulFileSize) {
            // t@CTCYs
            dwRet = SW_ERROR_FILE_SIZE;
        }
    }

	// m
    if (SW_SUCCESS == dwRet) {
	    // Kvł΃
		releaseData();
		
        // t@CTCYm
        m_pbProgram = (BYTE*)malloc((UINT)ulFileSize);
		if (m_pbProgram == NULL) {
			// t@C̓ǍɎs
			dwRet = SW_ERROR_FILE_READ;
		}
	}

	// Ǎ
	if (SW_SUCCESS == dwRet) {
        DWORD   dwReadBytes = 0UL;
        // xɑSǂݍ
        if (FALSE != ::ReadFile(hFile, m_pbProgram, (DWORD)ulFileSize, &dwReadBytes, NULL)) {
            // ǂݍ݃TCỸ`FbN
            if (dwReadBytes == ulFileSize) {
                // ǂݍ񂾃TCYێ
                m_dwProgramSize = dwReadBytes;
            }
            else {
                // t@C̓ǍɎs
			    dwRet = SW_ERROR_FILE_READ;
            }
        }
        else {
            // t@C̓ǍɎs
			dwRet = SW_ERROR_FILE_READ;
        }
	}

	// t@CB
    if( INVALID_HANDLE_VALUE != hFile) {
        CloseHandle(hFile);
    }

    if (SW_SUCCESS != dwRet) {
        // ܂ł̏ŃG[̏ꍇ̓B
        releaseData();
    }

	return dwRet;
}


//-----------------------------------------------------------------------------
// @outline     16i𐔒l܂B
// @explanation 16i𐔒l܂B
// @param       [IN]str	ϊΏە
//				[IN]len	ϊΏە̕
// @return		ϊ
//-----------------------------------------------------------------------------
int CTargetFileForMot::ascii2hex(const char *str, unsigned int len)
{
    DWORD	res = 0;

    unsigned int i = len;
    const char* pstr = str;
    for (; i; --i)
    {
        res <<= 4;
        if ('0' <= *pstr && '9' >= *pstr)
        {
            res += *pstr - '0';
        }
        else if ('A' <= *pstr && 'F' >= *pstr)
        {
            res += *pstr + 10 - 'A';
        }
        else if ('a' <= *pstr && 'f' >= *pstr)
        {
            res += *pstr + 10 - 'a';
        }
        else
        {
            return -1;
        }
        ++pstr;
    }

    return res;
}