/*
 * Copyright (c) 2012,2015 Renesas Electronics Corporation and TESSERA
 * TECHNOLOGY INC.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

//=============================================================================
// FileName : WaitingTimeCalculator.h
//=============================================================================
#pragma once

//=============================================================================
// 萔`
//=============================================================================
#define MILI_SECOND                 (1000UL)        // 1~b̒l
#define MIN_WAIT                    (100UL)         // ŏ҂
#define MARGIN_WAIT                 (100UL)         // }[W
#define MARGIN_WAIT_TCS6            (50UL)          // TCS6̃}[W

// MEMOF}[Wlɂ
//       RL78}CNRg[(RL78 vgRA)vO}҂
//       5 tbVEEp[^ x[Xɑ҂ԂZo
//       ܂ Windows ̓sÂ܂܂̒lł̓^CAEgƂȂĂ܂
//       ׁA҂Ԃ𒷖ڂɐݒ肵Ă܂B
//       ŎZo҂Ԃ́ASequenceProcessorNXŃ|[O
//       ĎgpĂ܂B
//=============================================================================
// NX`
//=============================================================================
//-----------------------------------------------------------------------------
// @outline		CWaitingTimeCalculator NX
// @explanation	҂ԂvZNXłB
//-----------------------------------------------------------------------------
class CWaitingTimeCalculator
{
public:
    // RXgN^
    CWaitingTimeCalculator(void);

    // fXgN^
    ~CWaitingTimeCalculator(void);

    // s܂B
    void Initialize(BYTE bFrequency, BOOL fFullSpeed);

    // Reset(tCS1)  ő҂Ԃ擾܂B(PʁFmsec)
    DWORD GetResetTcs1();

    // BlockErase(tCS3)  ő҂Ԃ擾܂B(PʁFmsec)
    DWORD GetBlockEraseTcs3(BOOL fCodeFlash);

    // BlockBlankCheck(tCS4)  ő҂Ԃ擾܂B(PʁFmsec)
    DWORD GetBlockBlankCheckTcs4(DWORD dwStartAddress, DWORD dwEndAddress, DWORD dwBlockCount, BOOL fCodeFlash);

    // Programming(tCS5)  ő҂Ԃ擾܂B(PʁFmsec)
    DWORD GetProgrammingTcs5(BOOL fCodeFlash);

    // Programming(tCD5)  ő҂Ԃ擾܂B(PʁFmsec)
    DWORD GetProgrammingTds5(BOOL fCodeFlash);

    // Programming(tSS5)  ő҂Ԃ擾܂B(PʁFmsec)
    DWORD GetProgrammingTss5(DWORD dwStartAddress, DWORD dwEndAddress, DWORD dwBlockCount, BOOL fCodeFlash);

    // BaudrateSet(tCS6)  ő҂Ԃ擾܂B(PʁFmsec)
    static DWORD GetBaudRateSetTcs6();

    // SecuritySet(tCS7)  ő҂Ԃ擾܂B(PʁFmsec)
    DWORD GetSecuritySetTcs7();

    // SecuritySet(tDS7)  ő҂Ԃ擾܂B(PʁFmsec)
    DWORD GetSecuritySetTds7();

    // SecurityGet(tCS8)  ő҂Ԃ擾܂B(PʁFmsec)
    DWORD GetSecurityGetTcs8();

    // SecurityGet(tSD8)  ő҂Ԃ擾܂B(PʁFmsec)
    DWORD GetSecurityGetTsd8();

    // SecurityRelease(tCS9)  ő҂Ԃ擾܂B(PʁFmsec)
    DWORD GetSecurityReleaseTcs9(DWORD dwCodeFlashBlockCount, DWORD dwDataFlashBlockCount);

    // Checksum(tCS10)  ő҂Ԃ擾܂B(PʁFmsec)
    DWORD GetCheckSumTcs10(BOOL fCodeFlash);

    // CheckSum(tSD10)  ő҂Ԃ擾܂B(PʁFmsec)
    DWORD GetCheckSumTsd10(DWORD dwBlockCount);

    // SilliconSignature(tCS11)  ő҂Ԃ擾܂B(PʁFmsec)
    DWORD GetSiliconSignatureTcs11();

    // SilliconSignature(tSD11)  ő҂Ԃ擾܂B(PʁFmsec)
    DWORD GetSiliconSignatureTsd11();

    // Af[^M̃f[^`f[^(tDT11)  ő҂Ԃ擾܂B(PʁFmsec)
    DWORD GetTdt();

private:
    // g(MHz)
    DWORD   m_bFrequency;
    
    // tXs[h[htO
    BOOL    m_fFullSpeed;

    // FlashANZX񐔂擾܂B
    DWORD   getFlashAccessFrequency(DWORD dwStartAddress, DWORD dwEndAddress);

    // FlashANZX񐔂擾܂B
    DWORD   getFlashAccessFrequency(DWORD dwCodeFlashBlockCount);
};
